#include "windows_version.h"
#include <memory.h>
#define CAML_NAME_SPACE
#include <caml/mlvalues.h>
#include <caml/socketaddr.h>
#include <caml/threads.h>
#include <uv.h>
#include "helpers.h"
#include "ctypes_cstubs_internals.h"
value luv_stub_1_uv_strerror_r(value x3, value x2, value x1)
{
   int x4 = Long_val(x3);
   unsigned char* x7 = CTYPES_PTR_OF_OCAML_BYTES(x2);
   int x8 = Long_val(x1);
   uv_strerror_r(x4, x7, x8);
   return Val_unit;
}
value luv_stub_2_uv_err_name_r(value x14, value x13, value x12)
{
   int x15 = Long_val(x14);
   unsigned char* x18 = CTYPES_PTR_OF_OCAML_BYTES(x13);
   int x19 = Long_val(x12);
   uv_err_name_r(x15, x18, x19);
   return Val_unit;
}
value luv_stub_3_uv_translate_sys_error(value x23)
{
   int x24 = Long_val(x23);
   int x27 = uv_translate_sys_error(x24);
   return Val_long(x27);
}
value luv_stub_4_luv_version_suffix(value x28)
{
   char* x29 = luv_version_suffix();
   return CTYPES_FROM_PTR(x29);
}
value luv_stub_5_uv_version(value x30)
{
   int x31 = uv_version();
   return Val_long(x31);
}
value luv_stub_6_luv_version_string(value x32)
{
   char* x33 = luv_version_string();
   return CTYPES_FROM_PTR(x33);
}
value luv_stub_7_uv_loop_init(value x34)
{
   uv_loop_t* x35 = CTYPES_ADDR_OF_FATPTR(x34);
   int x36 = uv_loop_init(x35);
   return Val_long(x36);
}
value luv_stub_8_uv_loop_configure(value x39, value x38, value x37)
{
   uv_loop_t* x40 = CTYPES_ADDR_OF_FATPTR(x39);
   int x41 = Long_val(x38);
   int x44 = Long_val(x37);
   int x47 = uv_loop_configure(x40, x41, x44);
   return Val_long(x47);
}
value luv_stub_9_uv_loop_close(value x48)
{
   uv_loop_t* x49 = CTYPES_ADDR_OF_FATPTR(x48);
   int x50 = uv_loop_close(x49);
   return Val_long(x50);
}
value luv_stub_10_uv_default_loop(value x51)
{
   uv_loop_t* x52 = uv_default_loop();
   return CTYPES_FROM_PTR(x52);
}
value luv_stub_11_uv_loop_alive(value x53)
{
   uv_loop_t* x54 = CTYPES_ADDR_OF_FATPTR(x53);
   _Bool x55 = uv_loop_alive(x54);
   return Val_bool(x55);
}
value luv_stub_12_uv_stop(value x56)
{
   uv_loop_t* x57 = CTYPES_ADDR_OF_FATPTR(x56);
   uv_stop(x57);
   return Val_unit;
}
value luv_stub_13_uv_backend_fd(value x59)
{
   uv_loop_t* x60 = CTYPES_ADDR_OF_FATPTR(x59);
   int x61 = uv_backend_fd(x60);
   return Val_long(x61);
}
value luv_stub_14_uv_backend_timeout(value x62)
{
   uv_loop_t* x63 = CTYPES_ADDR_OF_FATPTR(x62);
   int x64 = uv_backend_timeout(x63);
   return Val_long(x64);
}
value luv_stub_15_uv_now(value x65)
{
   uv_loop_t* x66 = CTYPES_ADDR_OF_FATPTR(x65);
   uint64_t x67 = uv_now(x66);
   return integers_copy_uint64(x67);
}
value luv_stub_16_uv_update_time(value x68)
{
   uv_loop_t* x69 = CTYPES_ADDR_OF_FATPTR(x68);
   uv_update_time(x69);
   return Val_unit;
}
value luv_stub_17_uv_loop_fork(value x71)
{
   uv_loop_t* x72 = CTYPES_ADDR_OF_FATPTR(x71);
   int x73 = uv_loop_fork(x72);
   return Val_long(x73);
}
value luv_stub_18_uv_library_shutdown(value x74)
{
   uv_library_shutdown();
   return Val_unit;
}
value luv_stub_19_luv_get_close_trampoline(value x76)
{
   void(* x77)(uv_handle_t*) = luv_get_close_trampoline();
   return CTYPES_FROM_PTR(x77);
}
value luv_stub_20_luv_get_alloc_trampoline(value x78)
{
   void(* x79)(uv_handle_t*, size_t, uv_buf_t*) = luv_get_alloc_trampoline();
   return CTYPES_FROM_PTR(x79);
}
value luv_stub_21_uv_is_active(value x80)
{
   uv_handle_t* x81 = CTYPES_ADDR_OF_FATPTR(x80);
   _Bool x82 = uv_is_active(x81);
   return Val_bool(x82);
}
value luv_stub_22_uv_is_closing(value x83)
{
   uv_handle_t* x84 = CTYPES_ADDR_OF_FATPTR(x83);
   _Bool x85 = uv_is_closing(x84);
   return Val_bool(x85);
}
value luv_stub_23_uv_close(value x87, value x86)
{
   uv_handle_t* x88 = CTYPES_ADDR_OF_FATPTR(x87);
   void(* x89)(uv_handle_t*) = CTYPES_ADDR_OF_FATPTR(x86);
   uv_close(x88, x89);
   return Val_unit;
}
value luv_stub_24_uv_ref(value x91)
{
   uv_handle_t* x92 = CTYPES_ADDR_OF_FATPTR(x91);
   uv_ref(x92);
   return Val_unit;
}
value luv_stub_25_uv_unref(value x94)
{
   uv_handle_t* x95 = CTYPES_ADDR_OF_FATPTR(x94);
   uv_unref(x95);
   return Val_unit;
}
value luv_stub_26_uv_has_ref(value x97)
{
   uv_handle_t* x98 = CTYPES_ADDR_OF_FATPTR(x97);
   _Bool x99 = uv_has_ref(x98);
   return Val_bool(x99);
}
value luv_stub_27_uv_send_buffer_size(value x101, value x100)
{
   uv_handle_t* x102 = CTYPES_ADDR_OF_FATPTR(x101);
   int* x103 = CTYPES_ADDR_OF_FATPTR(x100);
   int x104 = uv_send_buffer_size(x102, x103);
   return Val_long(x104);
}
value luv_stub_28_uv_recv_buffer_size(value x106, value x105)
{
   uv_handle_t* x107 = CTYPES_ADDR_OF_FATPTR(x106);
   int* x108 = CTYPES_ADDR_OF_FATPTR(x105);
   int x109 = uv_recv_buffer_size(x107, x108);
   return Val_long(x109);
}
value luv_stub_29_uv_fileno(value x111, value x110)
{
   uv_handle_t* x112 = CTYPES_ADDR_OF_FATPTR(x111);
   uv_os_fd_t* x113 = CTYPES_ADDR_OF_FATPTR(x110);
   int x114 = uv_fileno(x112, x113);
   return Val_long(x114);
}
value luv_stub_30_uv_handle_get_loop(value x115)
{
   uv_handle_t* x116 = CTYPES_ADDR_OF_FATPTR(x115);
   uv_loop_t* x117 = uv_handle_get_loop(x116);
   return CTYPES_FROM_PTR(x117);
}
value luv_stub_31_uv_handle_get_data(value x118)
{
   uv_handle_t* x119 = CTYPES_ADDR_OF_FATPTR(x118);
   void* x120 = uv_handle_get_data(x119);
   return CTYPES_FROM_PTR(x120);
}
value luv_stub_32_uv_handle_set_data(value x122, value x121)
{
   uv_handle_t* x123 = CTYPES_ADDR_OF_FATPTR(x122);
   void* x124 = CTYPES_ADDR_OF_FATPTR(x121);
   uv_handle_set_data(x123, x124);
   return Val_unit;
}
value luv_stub_33_uv_cancel(value x126)
{
   uv_req_t* x127 = CTYPES_ADDR_OF_FATPTR(x126);
   int x128 = uv_cancel(x127);
   return Val_long(x128);
}
value luv_stub_34_uv_req_get_data(value x129)
{
   uv_req_t* x130 = CTYPES_ADDR_OF_FATPTR(x129);
   void* x131 = uv_req_get_data(x130);
   return CTYPES_FROM_PTR(x131);
}
value luv_stub_35_uv_req_set_data(value x133, value x132)
{
   uv_req_t* x134 = CTYPES_ADDR_OF_FATPTR(x133);
   void* x135 = CTYPES_ADDR_OF_FATPTR(x132);
   uv_req_set_data(x134, x135);
   return Val_unit;
}
value luv_stub_36_luv_get_timer_trampoline(value x137)
{
   void(* x138)(uv_timer_t*) = luv_get_timer_trampoline();
   return CTYPES_FROM_PTR(x138);
}
value luv_stub_37_uv_timer_init(value x140, value x139)
{
   uv_loop_t* x141 = CTYPES_ADDR_OF_FATPTR(x140);
   uv_timer_t* x142 = CTYPES_ADDR_OF_FATPTR(x139);
   int x143 = uv_timer_init(x141, x142);
   return Val_long(x143);
}
value luv_stub_38_uv_timer_start(value x147, value x146, value x145,
                                 value x144)
{
   uv_timer_t* x148 = CTYPES_ADDR_OF_FATPTR(x147);
   void(* x149)(uv_timer_t*) = CTYPES_ADDR_OF_FATPTR(x146);
   uint64_t x150 = Uint64_val(x145);
   uint64_t x153 = Uint64_val(x144);
   int x156 = uv_timer_start(x148, x149, x150, x153);
   return Val_long(x156);
}
value luv_stub_39_uv_timer_stop(value x157)
{
   uv_timer_t* x158 = CTYPES_ADDR_OF_FATPTR(x157);
   int x159 = uv_timer_stop(x158);
   return Val_long(x159);
}
value luv_stub_40_uv_timer_again(value x160)
{
   uv_timer_t* x161 = CTYPES_ADDR_OF_FATPTR(x160);
   int x162 = uv_timer_again(x161);
   return Val_long(x162);
}
value luv_stub_41_uv_timer_set_repeat(value x164, value x163)
{
   uv_timer_t* x165 = CTYPES_ADDR_OF_FATPTR(x164);
   uint64_t x166 = Uint64_val(x163);
   uv_timer_set_repeat(x165, x166);
   return Val_unit;
}
value luv_stub_42_uv_timer_get_repeat(value x170)
{
   uv_timer_t* x171 = CTYPES_ADDR_OF_FATPTR(x170);
   uint64_t x172 = uv_timer_get_repeat(x171);
   return integers_copy_uint64(x172);
}
value luv_stub_43_uv_timer_get_due_in(value x173)
{
   uv_timer_t* x174 = CTYPES_ADDR_OF_FATPTR(x173);
   uint64_t x175 = uv_timer_get_due_in(x174);
   return integers_copy_uint64(x175);
}
value luv_stub_44_luv_get_prepare_trampoline(value x176)
{
   void(* x177)(uv_prepare_t*) = luv_get_prepare_trampoline();
   return CTYPES_FROM_PTR(x177);
}
value luv_stub_45_uv_prepare_init(value x179, value x178)
{
   uv_loop_t* x180 = CTYPES_ADDR_OF_FATPTR(x179);
   uv_prepare_t* x181 = CTYPES_ADDR_OF_FATPTR(x178);
   int x182 = uv_prepare_init(x180, x181);
   return Val_long(x182);
}
value luv_stub_46_uv_prepare_start(value x184, value x183)
{
   uv_prepare_t* x185 = CTYPES_ADDR_OF_FATPTR(x184);
   void(* x186)(uv_prepare_t*) = CTYPES_ADDR_OF_FATPTR(x183);
   int x187 = uv_prepare_start(x185, x186);
   return Val_long(x187);
}
value luv_stub_47_uv_prepare_stop(value x188)
{
   uv_prepare_t* x189 = CTYPES_ADDR_OF_FATPTR(x188);
   int x190 = uv_prepare_stop(x189);
   return Val_long(x190);
}
value luv_stub_48_luv_get_check_trampoline(value x191)
{
   void(* x192)(uv_check_t*) = luv_get_check_trampoline();
   return CTYPES_FROM_PTR(x192);
}
value luv_stub_49_uv_check_init(value x194, value x193)
{
   uv_loop_t* x195 = CTYPES_ADDR_OF_FATPTR(x194);
   uv_check_t* x196 = CTYPES_ADDR_OF_FATPTR(x193);
   int x197 = uv_check_init(x195, x196);
   return Val_long(x197);
}
value luv_stub_50_uv_check_start(value x199, value x198)
{
   uv_check_t* x200 = CTYPES_ADDR_OF_FATPTR(x199);
   void(* x201)(uv_check_t*) = CTYPES_ADDR_OF_FATPTR(x198);
   int x202 = uv_check_start(x200, x201);
   return Val_long(x202);
}
value luv_stub_51_uv_check_stop(value x203)
{
   uv_check_t* x204 = CTYPES_ADDR_OF_FATPTR(x203);
   int x205 = uv_check_stop(x204);
   return Val_long(x205);
}
value luv_stub_52_luv_get_idle_trampoline(value x206)
{
   void(* x207)(uv_idle_t*) = luv_get_idle_trampoline();
   return CTYPES_FROM_PTR(x207);
}
value luv_stub_53_uv_idle_init(value x209, value x208)
{
   uv_loop_t* x210 = CTYPES_ADDR_OF_FATPTR(x209);
   uv_idle_t* x211 = CTYPES_ADDR_OF_FATPTR(x208);
   int x212 = uv_idle_init(x210, x211);
   return Val_long(x212);
}
value luv_stub_54_uv_idle_start(value x214, value x213)
{
   uv_idle_t* x215 = CTYPES_ADDR_OF_FATPTR(x214);
   void(* x216)(uv_idle_t*) = CTYPES_ADDR_OF_FATPTR(x213);
   int x217 = uv_idle_start(x215, x216);
   return Val_long(x217);
}
value luv_stub_55_uv_idle_stop(value x218)
{
   uv_idle_t* x219 = CTYPES_ADDR_OF_FATPTR(x218);
   int x220 = uv_idle_stop(x219);
   return Val_long(x220);
}
value luv_stub_56_luv_get_async_trampoline(value x221)
{
   void(* x222)(uv_async_t*) = luv_get_async_trampoline();
   return CTYPES_FROM_PTR(x222);
}
value luv_stub_57_uv_async_init(value x225, value x224, value x223)
{
   uv_loop_t* x226 = CTYPES_ADDR_OF_FATPTR(x225);
   uv_async_t* x227 = CTYPES_ADDR_OF_FATPTR(x224);
   void(* x228)(uv_async_t*) = CTYPES_ADDR_OF_FATPTR(x223);
   int x229 = uv_async_init(x226, x227, x228);
   return Val_long(x229);
}
value luv_stub_58_uv_async_send(value x230)
{
   uv_async_t* x231 = CTYPES_ADDR_OF_FATPTR(x230);
   int x232 = uv_async_send(x231);
   return Val_long(x232);
}
value luv_stub_59_luv_get_poll_trampoline(value x233)
{
   void(* x234)(uv_poll_t*, int, int) = luv_get_poll_trampoline();
   return CTYPES_FROM_PTR(x234);
}
value luv_stub_60_uv_poll_init(value x237, value x236, value x235)
{
   uv_loop_t* x238 = CTYPES_ADDR_OF_FATPTR(x237);
   uv_poll_t* x239 = CTYPES_ADDR_OF_FATPTR(x236);
   int x240 = Long_val(x235);
   int x243 = uv_poll_init(x238, x239, x240);
   return Val_long(x243);
}
value luv_stub_61_uv_poll_init_socket(value x246, value x245, value x244)
{
   uv_loop_t* x247 = CTYPES_ADDR_OF_FATPTR(x246);
   uv_poll_t* x248 = CTYPES_ADDR_OF_FATPTR(x245);
   void* x249 = CTYPES_ADDR_OF_FATPTR(x244);
   uv_os_sock_t x251 = *(uv_os_sock_t*)x249;
   int x252 = uv_poll_init_socket(x247, x248, x251);
   return Val_long(x252);
}
value luv_stub_62_uv_poll_start(value x255, value x254, value x253)
{
   uv_poll_t* x256 = CTYPES_ADDR_OF_FATPTR(x255);
   int x257 = Long_val(x254);
   void(* x260)(uv_poll_t*, int, int) = CTYPES_ADDR_OF_FATPTR(x253);
   int x261 = uv_poll_start(x256, x257, x260);
   return Val_long(x261);
}
value luv_stub_63_uv_poll_stop(value x262)
{
   uv_poll_t* x263 = CTYPES_ADDR_OF_FATPTR(x262);
   int x264 = uv_poll_stop(x263);
   return Val_long(x264);
}
value luv_stub_64_luv_get_signal_trampoline(value x265)
{
   void(* x266)(uv_signal_t*, int) = luv_get_signal_trampoline();
   return CTYPES_FROM_PTR(x266);
}
value luv_stub_65_uv_signal_init(value x268, value x267)
{
   uv_loop_t* x269 = CTYPES_ADDR_OF_FATPTR(x268);
   uv_signal_t* x270 = CTYPES_ADDR_OF_FATPTR(x267);
   int x271 = uv_signal_init(x269, x270);
   return Val_long(x271);
}
value luv_stub_66_uv_signal_start(value x274, value x273, value x272)
{
   uv_signal_t* x275 = CTYPES_ADDR_OF_FATPTR(x274);
   void(* x276)(uv_signal_t*, int) = CTYPES_ADDR_OF_FATPTR(x273);
   int x277 = Long_val(x272);
   int x280 = uv_signal_start(x275, x276, x277);
   return Val_long(x280);
}
value luv_stub_67_uv_signal_start_oneshot(value x283, value x282, value x281)
{
   uv_signal_t* x284 = CTYPES_ADDR_OF_FATPTR(x283);
   void(* x285)(uv_signal_t*, int) = CTYPES_ADDR_OF_FATPTR(x282);
   int x286 = Long_val(x281);
   int x289 = uv_signal_start_oneshot(x284, x285, x286);
   return Val_long(x289);
}
value luv_stub_68_uv_signal_stop(value x290)
{
   uv_signal_t* x291 = CTYPES_ADDR_OF_FATPTR(x290);
   int x292 = uv_signal_stop(x291);
   return Val_long(x292);
}
value luv_stub_69_luv_get_connect_trampoline(value x293)
{
   void(* x294)(uv_connect_t*, int) = luv_get_connect_trampoline();
   return CTYPES_FROM_PTR(x294);
}
value luv_stub_70_luv_get_shutdown_trampoline(value x295)
{
   void(* x296)(uv_shutdown_t*, int) = luv_get_shutdown_trampoline();
   return CTYPES_FROM_PTR(x296);
}
value luv_stub_71_luv_get_write_trampoline(value x297)
{
   void(* x298)(uv_write_t*, int) = luv_get_write_trampoline();
   return CTYPES_FROM_PTR(x298);
}
value luv_stub_72_luv_get_connection_trampoline(value x299)
{
   void(* x300)(uv_stream_t*, int) = luv_get_connection_trampoline();
   return CTYPES_FROM_PTR(x300);
}
value luv_stub_73_luv_get_read_trampoline(value x301)
{
   void(* x302)(uv_stream_t*, ssize_t, uv_buf_t*) = luv_get_read_trampoline();
   return CTYPES_FROM_PTR(x302);
}
value luv_stub_74_uv_shutdown(value x305, value x304, value x303)
{
   uv_shutdown_t* x306 = CTYPES_ADDR_OF_FATPTR(x305);
   uv_stream_t* x307 = CTYPES_ADDR_OF_FATPTR(x304);
   void(* x308)(uv_shutdown_t*, int) = CTYPES_ADDR_OF_FATPTR(x303);
   int x309 = uv_shutdown(x306, x307, x308);
   return Val_long(x309);
}
value luv_stub_75_uv_listen(value x312, value x311, value x310)
{
   uv_stream_t* x313 = CTYPES_ADDR_OF_FATPTR(x312);
   int x314 = Long_val(x311);
   void(* x317)(uv_stream_t*, int) = CTYPES_ADDR_OF_FATPTR(x310);
   int x318 = uv_listen(x313, x314, x317);
   return Val_long(x318);
}
value luv_stub_76_uv_accept(value x320, value x319)
{
   uv_stream_t* x321 = CTYPES_ADDR_OF_FATPTR(x320);
   uv_stream_t* x322 = CTYPES_ADDR_OF_FATPTR(x319);
   int x323 = uv_accept(x321, x322);
   return Val_long(x323);
}
value luv_stub_77_luv_read_start(value x326, value x325, value x324)
{
   uv_stream_t* x327 = CTYPES_ADDR_OF_FATPTR(x326);
   void(* x328)(uv_handle_t*, size_t, uv_buf_t*) =
   CTYPES_ADDR_OF_FATPTR(x325);
   void(* x329)(uv_stream_t*, ssize_t, uv_buf_t*) =
   CTYPES_ADDR_OF_FATPTR(x324);
   int x330 = luv_read_start(x327, x328, x329);
   return Val_long(x330);
}
value luv_stub_78_uv_read_stop(value x331)
{
   uv_stream_t* x332 = CTYPES_ADDR_OF_FATPTR(x331);
   int x333 = uv_read_stop(x332);
   return Val_long(x333);
}
value luv_stub_79_uv_write2(value x339, value x338, value x337, value x336,
                            value x335, value x334)
{
   uv_write_t* x340 = CTYPES_ADDR_OF_FATPTR(x339);
   uv_stream_t* x341 = CTYPES_ADDR_OF_FATPTR(x338);
   uv_buf_t* x342 = CTYPES_ADDR_OF_FATPTR(x337);
   unsigned int x343 = ctypes_uint_val(x336);
   uv_stream_t* x346 = CTYPES_ADDR_OF_FATPTR(x335);
   void(* x347)(uv_write_t*, int) = CTYPES_ADDR_OF_FATPTR(x334);
   int x348 = uv_write2(x340, x341, x342, x343, x346, x347);
   return Val_long(x348);
}
value luv_stub_79_uv_write2_byte6(value* argv, int argc)
{
   value x349 = argv[5];
   value x350 = argv[4];
   value x351 = argv[3];
   value x352 = argv[2];
   value x353 = argv[1];
   value x354 = argv[0];
   return luv_stub_79_uv_write2(x354, x353, x352, x351, x350, x349);
}
value luv_stub_80_uv_try_write(value x357, value x356, value x355)
{
   uv_stream_t* x358 = CTYPES_ADDR_OF_FATPTR(x357);
   uv_buf_t* x359 = CTYPES_ADDR_OF_FATPTR(x356);
   unsigned int x360 = ctypes_uint_val(x355);
   int x363 = uv_try_write(x358, x359, x360);
   return Val_long(x363);
}
value luv_stub_81_uv_try_write2(value x367, value x366, value x365,
                                value x364)
{
   uv_stream_t* x368 = CTYPES_ADDR_OF_FATPTR(x367);
   uv_buf_t* x369 = CTYPES_ADDR_OF_FATPTR(x366);
   unsigned int x370 = ctypes_uint_val(x365);
   uv_stream_t* x373 = CTYPES_ADDR_OF_FATPTR(x364);
   int x374 = uv_try_write2(x368, x369, x370, x373);
   return Val_long(x374);
}
value luv_stub_82_uv_is_readable(value x375)
{
   uv_stream_t* x376 = CTYPES_ADDR_OF_FATPTR(x375);
   _Bool x377 = uv_is_readable(x376);
   return Val_bool(x377);
}
value luv_stub_83_uv_is_writable(value x378)
{
   uv_stream_t* x379 = CTYPES_ADDR_OF_FATPTR(x378);
   _Bool x380 = uv_is_writable(x379);
   return Val_bool(x380);
}
value luv_stub_84_uv_stream_set_blocking(value x382, value x381)
{
   uv_stream_t* x383 = CTYPES_ADDR_OF_FATPTR(x382);
   _Bool x384 = Bool_val(x381);
   int x387 = uv_stream_set_blocking(x383, x384);
   return Val_long(x387);
}
value luv_stub_85_uv_stream_get_write_queue_size(value x388)
{
   uv_stream_t* x389 = CTYPES_ADDR_OF_FATPTR(x388);
   size_t x390 = uv_stream_get_write_queue_size(x389);
   return ctypes_copy_size_t(x390);
}
value luv_stub_86_uv_tcp_init(value x392, value x391)
{
   uv_loop_t* x393 = CTYPES_ADDR_OF_FATPTR(x392);
   uv_tcp_t* x394 = CTYPES_ADDR_OF_FATPTR(x391);
   int x395 = uv_tcp_init(x393, x394);
   return Val_long(x395);
}
value luv_stub_87_uv_tcp_init_ex(value x398, value x397, value x396)
{
   uv_loop_t* x399 = CTYPES_ADDR_OF_FATPTR(x398);
   uv_tcp_t* x400 = CTYPES_ADDR_OF_FATPTR(x397);
   unsigned int x401 = ctypes_uint_val(x396);
   int x404 = uv_tcp_init_ex(x399, x400, x401);
   return Val_long(x404);
}
value luv_stub_88_uv_tcp_open(value x406, value x405)
{
   uv_tcp_t* x407 = CTYPES_ADDR_OF_FATPTR(x406);
   void* x408 = CTYPES_ADDR_OF_FATPTR(x405);
   uv_os_sock_t x410 = *(uv_os_sock_t*)x408;
   int x411 = uv_tcp_open(x407, x410);
   return Val_long(x411);
}
value luv_stub_89_uv_socketpair(value x416, value x415, value x414,
                                value x413, value x412)
{
   int x417 = Long_val(x416);
   int x420 = Long_val(x415);
   uv_os_sock_t* x423 = CTYPES_ADDR_OF_FATPTR(x414);
   int x424 = Long_val(x413);
   int x427 = Long_val(x412);
   int x430 = uv_socketpair(x417, x420, x423, x424, x427);
   return Val_long(x430);
}
value luv_stub_90_uv_tcp_nodelay(value x432, value x431)
{
   uv_tcp_t* x433 = CTYPES_ADDR_OF_FATPTR(x432);
   _Bool x434 = Bool_val(x431);
   int x437 = uv_tcp_nodelay(x433, x434);
   return Val_long(x437);
}
value luv_stub_91_uv_tcp_keepalive(value x440, value x439, value x438)
{
   uv_tcp_t* x441 = CTYPES_ADDR_OF_FATPTR(x440);
   _Bool x442 = Bool_val(x439);
   int x445 = Long_val(x438);
   int x448 = uv_tcp_keepalive(x441, x442, x445);
   return Val_long(x448);
}
value luv_stub_92_uv_tcp_simultaneous_accepts(value x450, value x449)
{
   uv_tcp_t* x451 = CTYPES_ADDR_OF_FATPTR(x450);
   _Bool x452 = Bool_val(x449);
   int x455 = uv_tcp_simultaneous_accepts(x451, x452);
   return Val_long(x455);
}
value luv_stub_93_uv_tcp_bind(value x458, value x457, value x456)
{
   uv_tcp_t* x459 = CTYPES_ADDR_OF_FATPTR(x458);
   struct sockaddr* x460 = CTYPES_ADDR_OF_FATPTR(x457);
   int x461 = Long_val(x456);
   int x464 = uv_tcp_bind(x459, x460, x461);
   return Val_long(x464);
}
value luv_stub_94_uv_tcp_getsockname(value x467, value x466, value x465)
{
   uv_tcp_t* x468 = CTYPES_ADDR_OF_FATPTR(x467);
   struct sockaddr* x469 = CTYPES_ADDR_OF_FATPTR(x466);
   int* x470 = CTYPES_ADDR_OF_FATPTR(x465);
   int x471 = uv_tcp_getsockname(x468, x469, x470);
   return Val_long(x471);
}
value luv_stub_95_uv_tcp_getpeername(value x474, value x473, value x472)
{
   uv_tcp_t* x475 = CTYPES_ADDR_OF_FATPTR(x474);
   struct sockaddr* x476 = CTYPES_ADDR_OF_FATPTR(x473);
   int* x477 = CTYPES_ADDR_OF_FATPTR(x472);
   int x478 = uv_tcp_getpeername(x475, x476, x477);
   return Val_long(x478);
}
value luv_stub_96_uv_tcp_connect(value x482, value x481, value x480,
                                 value x479)
{
   uv_connect_t* x483 = CTYPES_ADDR_OF_FATPTR(x482);
   uv_tcp_t* x484 = CTYPES_ADDR_OF_FATPTR(x481);
   struct sockaddr* x485 = CTYPES_ADDR_OF_FATPTR(x480);
   void(* x486)(uv_connect_t*, int) = CTYPES_ADDR_OF_FATPTR(x479);
   int x487 = uv_tcp_connect(x483, x484, x485, x486);
   return Val_long(x487);
}
value luv_stub_97_uv_tcp_close_reset(value x489, value x488)
{
   uv_tcp_t* x490 = CTYPES_ADDR_OF_FATPTR(x489);
   void(* x491)(uv_handle_t*) = CTYPES_ADDR_OF_FATPTR(x488);
   int x492 = uv_tcp_close_reset(x490, x491);
   return Val_long(x492);
}
value luv_stub_98_uv_pipe_init(value x495, value x494, value x493)
{
   uv_loop_t* x496 = CTYPES_ADDR_OF_FATPTR(x495);
   uv_pipe_t* x497 = CTYPES_ADDR_OF_FATPTR(x494);
   _Bool x498 = Bool_val(x493);
   int x501 = uv_pipe_init(x496, x497, x498);
   return Val_long(x501);
}
value luv_stub_99_uv_pipe(value x504, value x503, value x502)
{
   int* x505 = CTYPES_ADDR_OF_FATPTR(x504);
   int x506 = Long_val(x503);
   int x509 = Long_val(x502);
   int x512 = uv_pipe(x505, x506, x509);
   return Val_long(x512);
}
value luv_stub_100_uv_pipe_open(value x514, value x513)
{
   uv_pipe_t* x515 = CTYPES_ADDR_OF_FATPTR(x514);
   int x516 = Long_val(x513);
   int x519 = uv_pipe_open(x515, x516);
   return Val_long(x519);
}
value luv_stub_101_uv_pipe_connect(value x523, value x522, value x521,
                                   value x520)
{
   uv_connect_t* x524 = CTYPES_ADDR_OF_FATPTR(x523);
   uv_pipe_t* x525 = CTYPES_ADDR_OF_FATPTR(x522);
   char* x526 = CTYPES_PTR_OF_OCAML_STRING(x521);
   void(* x527)(uv_connect_t*, int) = CTYPES_ADDR_OF_FATPTR(x520);
   uv_pipe_connect(x524, x525, x526, x527);
   return Val_unit;
}
value luv_stub_102_uv_pipe_getsockname(value x531, value x530, value x529)
{
   uv_pipe_t* x532 = CTYPES_ADDR_OF_FATPTR(x531);
   unsigned char* x533 = CTYPES_PTR_OF_OCAML_BYTES(x530);
   size_t* x534 = CTYPES_ADDR_OF_FATPTR(x529);
   int x535 = uv_pipe_getsockname(x532, x533, x534);
   return Val_long(x535);
}
value luv_stub_103_uv_pipe_getpeername(value x538, value x537, value x536)
{
   uv_pipe_t* x539 = CTYPES_ADDR_OF_FATPTR(x538);
   unsigned char* x540 = CTYPES_PTR_OF_OCAML_BYTES(x537);
   size_t* x541 = CTYPES_ADDR_OF_FATPTR(x536);
   int x542 = uv_pipe_getpeername(x539, x540, x541);
   return Val_long(x542);
}
value luv_stub_104_uv_pipe_pending_instances(value x544, value x543)
{
   uv_pipe_t* x545 = CTYPES_ADDR_OF_FATPTR(x544);
   int x546 = Long_val(x543);
   uv_pipe_pending_instances(x545, x546);
   return Val_unit;
}
value luv_stub_105_uv_pipe_pending_count(value x550)
{
   uv_pipe_t* x551 = CTYPES_ADDR_OF_FATPTR(x550);
   int x552 = uv_pipe_pending_count(x551);
   return Val_long(x552);
}
value luv_stub_106_uv_pipe_pending_type(value x553)
{
   uv_pipe_t* x554 = CTYPES_ADDR_OF_FATPTR(x553);
   int x555 = uv_pipe_pending_type(x554);
   return Val_long(x555);
}
value luv_stub_107_uv_pipe_chmod(value x557, value x556)
{
   uv_pipe_t* x558 = CTYPES_ADDR_OF_FATPTR(x557);
   int x559 = Long_val(x556);
   int x562 = uv_pipe_chmod(x558, x559);
   return Val_long(x562);
}
value luv_stub_108_uv_tty_init(value x566, value x565, value x564,
                               value x563)
{
   uv_loop_t* x567 = CTYPES_ADDR_OF_FATPTR(x566);
   uv_tty_t* x568 = CTYPES_ADDR_OF_FATPTR(x565);
   int x569 = Long_val(x564);
   int x572 = Long_val(x563);
   int x575 = uv_tty_init(x567, x568, x569, x572);
   return Val_long(x575);
}
value luv_stub_109_uv_tty_set_mode(value x577, value x576)
{
   uv_tty_t* x578 = CTYPES_ADDR_OF_FATPTR(x577);
   uint32_t x579 = Uint32_val(x576);
   int x582 = uv_tty_set_mode(x578, x579);
   return Val_long(x582);
}
value luv_stub_110_uv_tty_reset_mode(value x583)
{
   int x584 = uv_tty_reset_mode();
   return Val_long(x584);
}
value luv_stub_111_uv_tty_get_winsize(value x587, value x586, value x585)
{
   uv_tty_t* x588 = CTYPES_ADDR_OF_FATPTR(x587);
   int* x589 = CTYPES_ADDR_OF_FATPTR(x586);
   int* x590 = CTYPES_ADDR_OF_FATPTR(x585);
   int x591 = uv_tty_get_winsize(x588, x589, x590);
   return Val_long(x591);
}
value luv_stub_112_uv_tty_set_vterm_state(value x592)
{
   uint32_t x593 = Uint32_val(x592);
   uv_tty_set_vterm_state(x593);
   return Val_unit;
}
value luv_stub_113_uv_tty_get_vterm_state(value x597)
{
   uv_tty_vtermstate_t* x598 = CTYPES_ADDR_OF_FATPTR(x597);
   int x599 = uv_tty_get_vterm_state(x598);
   return Val_long(x599);
}
value luv_stub_114_uv_udp_init(value x601, value x600)
{
   uv_loop_t* x602 = CTYPES_ADDR_OF_FATPTR(x601);
   uv_udp_t* x603 = CTYPES_ADDR_OF_FATPTR(x600);
   int x604 = uv_udp_init(x602, x603);
   return Val_long(x604);
}
value luv_stub_115_uv_udp_init_ex(value x607, value x606, value x605)
{
   uv_loop_t* x608 = CTYPES_ADDR_OF_FATPTR(x607);
   uv_udp_t* x609 = CTYPES_ADDR_OF_FATPTR(x606);
   unsigned int x610 = ctypes_uint_val(x605);
   int x613 = uv_udp_init_ex(x608, x609, x610);
   return Val_long(x613);
}
value luv_stub_116_uv_udp_open(value x615, value x614)
{
   uv_udp_t* x616 = CTYPES_ADDR_OF_FATPTR(x615);
   void* x617 = CTYPES_ADDR_OF_FATPTR(x614);
   uv_os_sock_t x619 = *(uv_os_sock_t*)x617;
   int x620 = uv_udp_open(x616, x619);
   return Val_long(x620);
}
value luv_stub_117_uv_udp_bind(value x623, value x622, value x621)
{
   uv_udp_t* x624 = CTYPES_ADDR_OF_FATPTR(x623);
   struct sockaddr* x625 = CTYPES_ADDR_OF_FATPTR(x622);
   int x626 = Long_val(x621);
   int x629 = uv_udp_bind(x624, x625, x626);
   return Val_long(x629);
}
value luv_stub_118_uv_udp_connect(value x631, value x630)
{
   uv_udp_t* x632 = CTYPES_ADDR_OF_FATPTR(x631);
   struct sockaddr* x633 = CTYPES_ADDR_OF_FATPTR(x630);
   int x634 = uv_udp_connect(x632, x633);
   return Val_long(x634);
}
value luv_stub_119_uv_udp_getpeername(value x637, value x636, value x635)
{
   uv_udp_t* x638 = CTYPES_ADDR_OF_FATPTR(x637);
   struct sockaddr* x639 = CTYPES_ADDR_OF_FATPTR(x636);
   int* x640 = CTYPES_ADDR_OF_FATPTR(x635);
   int x641 = uv_udp_getpeername(x638, x639, x640);
   return Val_long(x641);
}
value luv_stub_120_uv_udp_getsockname(value x644, value x643, value x642)
{
   uv_udp_t* x645 = CTYPES_ADDR_OF_FATPTR(x644);
   struct sockaddr* x646 = CTYPES_ADDR_OF_FATPTR(x643);
   int* x647 = CTYPES_ADDR_OF_FATPTR(x642);
   int x648 = uv_udp_getsockname(x645, x646, x647);
   return Val_long(x648);
}
value luv_stub_121_uv_udp_set_membership(value x652, value x651, value x650,
                                         value x649)
{
   uv_udp_t* x653 = CTYPES_ADDR_OF_FATPTR(x652);
   char* x654 = CTYPES_PTR_OF_OCAML_STRING(x651);
   char* x655 = CTYPES_PTR_OF_OCAML_STRING(x650);
   uint32_t x656 = Uint32_val(x649);
   int x659 = uv_udp_set_membership(x653, x654, x655, x656);
   return Val_long(x659);
}
value luv_stub_122_uv_udp_set_source_membership(value x664, value x663,
                                                value x662, value x661,
                                                value x660)
{
   uv_udp_t* x665 = CTYPES_ADDR_OF_FATPTR(x664);
   char* x666 = CTYPES_PTR_OF_OCAML_STRING(x663);
   char* x667 = CTYPES_PTR_OF_OCAML_STRING(x662);
   char* x668 = CTYPES_PTR_OF_OCAML_STRING(x661);
   uint32_t x669 = Uint32_val(x660);
   int x672 = uv_udp_set_source_membership(x665, x666, x667, x668, x669);
   return Val_long(x672);
}
value luv_stub_123_uv_udp_set_multicast_loop(value x674, value x673)
{
   uv_udp_t* x675 = CTYPES_ADDR_OF_FATPTR(x674);
   _Bool x676 = Bool_val(x673);
   int x679 = uv_udp_set_multicast_loop(x675, x676);
   return Val_long(x679);
}
value luv_stub_124_uv_udp_set_multicast_ttl(value x681, value x680)
{
   uv_udp_t* x682 = CTYPES_ADDR_OF_FATPTR(x681);
   int x683 = Long_val(x680);
   int x686 = uv_udp_set_multicast_ttl(x682, x683);
   return Val_long(x686);
}
value luv_stub_125_uv_udp_set_multicast_interface(value x688, value x687)
{
   uv_udp_t* x689 = CTYPES_ADDR_OF_FATPTR(x688);
   char* x690 = CTYPES_PTR_OF_OCAML_STRING(x687);
   int x691 = uv_udp_set_multicast_interface(x689, x690);
   return Val_long(x691);
}
value luv_stub_126_uv_udp_set_broadcast(value x693, value x692)
{
   uv_udp_t* x694 = CTYPES_ADDR_OF_FATPTR(x693);
   _Bool x695 = Bool_val(x692);
   int x698 = uv_udp_set_broadcast(x694, x695);
   return Val_long(x698);
}
value luv_stub_127_uv_udp_set_ttl(value x700, value x699)
{
   uv_udp_t* x701 = CTYPES_ADDR_OF_FATPTR(x700);
   int x702 = Long_val(x699);
   int x705 = uv_udp_set_ttl(x701, x702);
   return Val_long(x705);
}
value luv_stub_128_luv_get_send_trampoline(value x706)
{
   void(* x707)(uv_udp_send_t*, int) = luv_get_send_trampoline();
   return CTYPES_FROM_PTR(x707);
}
value luv_stub_129_uv_udp_send(value x713, value x712, value x711,
                               value x710, value x709, value x708)
{
   uv_udp_send_t* x714 = CTYPES_ADDR_OF_FATPTR(x713);
   uv_udp_t* x715 = CTYPES_ADDR_OF_FATPTR(x712);
   uv_buf_t* x716 = CTYPES_ADDR_OF_FATPTR(x711);
   unsigned int x717 = ctypes_uint_val(x710);
   struct sockaddr* x720 = CTYPES_ADDR_OF_FATPTR(x709);
   void(* x721)(uv_udp_send_t*, int) = CTYPES_ADDR_OF_FATPTR(x708);
   int x722 = uv_udp_send(x714, x715, x716, x717, x720, x721);
   return Val_long(x722);
}
value luv_stub_129_uv_udp_send_byte6(value* argv, int argc)
{
   value x723 = argv[5];
   value x724 = argv[4];
   value x725 = argv[3];
   value x726 = argv[2];
   value x727 = argv[1];
   value x728 = argv[0];
   return luv_stub_129_uv_udp_send(x728, x727, x726, x725, x724, x723);
}
value luv_stub_130_uv_udp_try_send(value x732, value x731, value x730,
                                   value x729)
{
   uv_udp_t* x733 = CTYPES_ADDR_OF_FATPTR(x732);
   uv_buf_t* x734 = CTYPES_ADDR_OF_FATPTR(x731);
   unsigned int x735 = ctypes_uint_val(x730);
   struct sockaddr* x738 = CTYPES_ADDR_OF_FATPTR(x729);
   int x739 = uv_udp_try_send(x733, x734, x735, x738);
   return Val_long(x739);
}
value luv_stub_131_luv_get_recv_trampoline(value x740)
{
   void(* x741)(uv_udp_t*, ssize_t, uv_buf_t*, struct sockaddr*, unsigned int)
   = luv_get_recv_trampoline();
   return CTYPES_FROM_PTR(x741);
}
value luv_stub_132_luv_udp_recv_start(value x744, value x743, value x742)
{
   uv_udp_t* x745 = CTYPES_ADDR_OF_FATPTR(x744);
   void(* x746)(uv_handle_t*, size_t, uv_buf_t*) =
   CTYPES_ADDR_OF_FATPTR(x743);
   void(* x747)(uv_udp_t*, ssize_t, uv_buf_t*, struct sockaddr*, unsigned int)
   = CTYPES_ADDR_OF_FATPTR(x742);
   int x748 = luv_udp_recv_start(x745, x746, x747);
   return Val_long(x748);
}
value luv_stub_133_uv_udp_recv_stop(value x749)
{
   uv_udp_t* x750 = CTYPES_ADDR_OF_FATPTR(x749);
   int x751 = uv_udp_recv_stop(x750);
   return Val_long(x751);
}
value luv_stub_134_uv_udp_using_recvmmsg(value x752)
{
   uv_udp_t* x753 = CTYPES_ADDR_OF_FATPTR(x752);
   _Bool x754 = uv_udp_using_recvmmsg(x753);
   return Val_bool(x754);
}
value luv_stub_135_uv_udp_get_send_queue_size(value x755)
{
   uv_udp_t* x756 = CTYPES_ADDR_OF_FATPTR(x755);
   size_t x757 = uv_udp_get_send_queue_size(x756);
   return ctypes_copy_size_t(x757);
}
value luv_stub_136_uv_udp_get_send_queue_count(value x758)
{
   uv_udp_t* x759 = CTYPES_ADDR_OF_FATPTR(x758);
   size_t x760 = uv_udp_get_send_queue_count(x759);
   return ctypes_copy_size_t(x760);
}
value luv_stub_137_luv_get_exit_trampoline(value x761)
{
   void(* x762)(uv_process_t*, int64_t, int) = luv_get_exit_trampoline();
   return CTYPES_FROM_PTR(x762);
}
value luv_stub_138_luv_null_exit_trampoline(value x763)
{
   void(* x764)(uv_process_t*, int64_t, int) = luv_null_exit_trampoline();
   return CTYPES_FROM_PTR(x764);
}
value luv_stub_139_uv_disable_stdio_inheritance(value x765)
{
   uv_disable_stdio_inheritance();
   return Val_unit;
}
value luv_stub_140_luv_spawn(value x782, value x781, value x780, value x779,
                             value x778, value x777, value x776, value x775,
                             value x774, value x773, value x772, value x771,
                             value x770, value x769, value x768, value x767)
{
   uv_loop_t* x783 = CTYPES_ADDR_OF_FATPTR(x782);
   uv_process_t* x784 = CTYPES_ADDR_OF_FATPTR(x781);
   void(* x785)(uv_process_t*, int64_t, int) = CTYPES_ADDR_OF_FATPTR(x780);
   char* x786 = CTYPES_ADDR_OF_FATPTR(x779);
   char** x787 = CTYPES_ADDR_OF_FATPTR(x778);
   int x788 = Long_val(x777);
   char** x791 = CTYPES_ADDR_OF_FATPTR(x776);
   int x792 = Long_val(x775);
   _Bool x795 = Bool_val(x774);
   char* x798 = CTYPES_ADDR_OF_FATPTR(x773);
   _Bool x799 = Bool_val(x772);
   int x802 = Long_val(x771);
   int x805 = Long_val(x770);
   uv_stdio_container_t* x808 = CTYPES_ADDR_OF_FATPTR(x769);
   int x809 = Long_val(x768);
   int x812 = Long_val(x767);
   int x815 =
   luv_spawn(x783, x784, x785, x786, x787, x788, x791, x792, x795, x798,
             x799, x802, x805, x808, x809, x812);
   return Val_long(x815);
}
value luv_stub_140_luv_spawn_byte16(value* argv, int argc)
{
   value x816 = argv[15];
   value x817 = argv[14];
   value x818 = argv[13];
   value x819 = argv[12];
   value x820 = argv[11];
   value x821 = argv[10];
   value x822 = argv[9];
   value x823 = argv[8];
   value x824 = argv[7];
   value x825 = argv[6];
   value x826 = argv[5];
   value x827 = argv[4];
   value x828 = argv[3];
   value x829 = argv[2];
   value x830 = argv[1];
   value x831 = argv[0];
   return
     luv_stub_140_luv_spawn(x831, x830, x829, x828, x827, x826, x825, 
                            x824, x823, x822, x821, x820, x819, x818, 
                            x817, x816);
}
value luv_stub_141_uv_process_kill(value x833, value x832)
{
   uv_process_t* x834 = CTYPES_ADDR_OF_FATPTR(x833);
   int x835 = Long_val(x832);
   int x838 = uv_process_kill(x834, x835);
   return Val_long(x838);
}
value luv_stub_142_uv_kill(value x840, value x839)
{
   int x841 = Long_val(x840);
   int x844 = Long_val(x839);
   int x847 = uv_kill(x841, x844);
   return Val_long(x847);
}
value luv_stub_143_uv_process_get_pid(value x848)
{
   uv_process_t* x849 = CTYPES_ADDR_OF_FATPTR(x848);
   int x850 = uv_process_get_pid(x849);
   return Val_long(x850);
}
value luv_stub_144_luv_get_fs_event_trampoline(value x851)
{
   void(* x852)(uv_fs_event_t*, char*, int, int) =
   luv_get_fs_event_trampoline();
   return CTYPES_FROM_PTR(x852);
}
value luv_stub_145_uv_fs_event_init(value x854, value x853)
{
   uv_loop_t* x855 = CTYPES_ADDR_OF_FATPTR(x854);
   uv_fs_event_t* x856 = CTYPES_ADDR_OF_FATPTR(x853);
   int x857 = uv_fs_event_init(x855, x856);
   return Val_long(x857);
}
value luv_stub_146_luv_fs_event_start(value x861, value x860, value x859,
                                      value x858)
{
   uv_fs_event_t* x862 = CTYPES_ADDR_OF_FATPTR(x861);
   void(* x863)(uv_fs_event_t*, char*, int, int) =
   CTYPES_ADDR_OF_FATPTR(x860);
   char* x864 = CTYPES_PTR_OF_OCAML_STRING(x859);
   int x865 = Long_val(x858);
   int x868 = luv_fs_event_start(x862, x863, x864, x865);
   return Val_long(x868);
}
value luv_stub_147_uv_fs_event_stop(value x869)
{
   uv_fs_event_t* x870 = CTYPES_ADDR_OF_FATPTR(x869);
   int x871 = uv_fs_event_stop(x870);
   return Val_long(x871);
}
value luv_stub_148_luv_get_fs_poll_trampoline(value x872)
{
   void(* x873)(uv_fs_poll_t*, int, uv_stat_t*, uv_stat_t*) =
   luv_get_fs_poll_trampoline();
   return CTYPES_FROM_PTR(x873);
}
value luv_stub_149_uv_fs_poll_init(value x875, value x874)
{
   uv_loop_t* x876 = CTYPES_ADDR_OF_FATPTR(x875);
   uv_fs_poll_t* x877 = CTYPES_ADDR_OF_FATPTR(x874);
   int x878 = uv_fs_poll_init(x876, x877);
   return Val_long(x878);
}
value luv_stub_150_luv_fs_poll_start(value x882, value x881, value x880,
                                     value x879)
{
   uv_fs_poll_t* x883 = CTYPES_ADDR_OF_FATPTR(x882);
   void(* x884)(uv_fs_poll_t*, int, uv_stat_t*, uv_stat_t*) =
   CTYPES_ADDR_OF_FATPTR(x881);
   char* x885 = CTYPES_PTR_OF_OCAML_STRING(x880);
   int x886 = Long_val(x879);
   int x889 = luv_fs_poll_start(x883, x884, x885, x886);
   return Val_long(x889);
}
value luv_stub_151_uv_fs_poll_stop(value x890)
{
   uv_fs_poll_t* x891 = CTYPES_ADDR_OF_FATPTR(x890);
   int x892 = uv_fs_poll_stop(x891);
   return Val_long(x892);
}
value luv_stub_152_luv_get_getaddrinfo_trampoline(value x893)
{
   void(* x894)(uv_getaddrinfo_t*, int, struct addrinfo*) =
   luv_get_getaddrinfo_trampoline();
   return CTYPES_FROM_PTR(x894);
}
value luv_stub_153_uv_getaddrinfo(value x900, value x899, value x898,
                                  value x897, value x896, value x895)
{
   uv_loop_t* x901 = CTYPES_ADDR_OF_FATPTR(x900);
   uv_getaddrinfo_t* x902 = CTYPES_ADDR_OF_FATPTR(x899);
   void(* x903)(uv_getaddrinfo_t*, int, struct addrinfo*) =
   CTYPES_ADDR_OF_FATPTR(x898);
   char* x904 = CTYPES_ADDR_OF_FATPTR(x897);
   char* x905 = CTYPES_ADDR_OF_FATPTR(x896);
   struct addrinfo* x906 = CTYPES_ADDR_OF_FATPTR(x895);
   int x907 = uv_getaddrinfo(x901, x902, x903, x904, x905, x906);
   return Val_long(x907);
}
value luv_stub_153_uv_getaddrinfo_byte6(value* argv, int argc)
{
   value x908 = argv[5];
   value x909 = argv[4];
   value x910 = argv[3];
   value x911 = argv[2];
   value x912 = argv[1];
   value x913 = argv[0];
   return luv_stub_153_uv_getaddrinfo(x913, x912, x911, x910, x909, x908);
}
value luv_stub_154_uv_freeaddrinfo(value x914)
{
   struct addrinfo* x915 = CTYPES_ADDR_OF_FATPTR(x914);
   uv_freeaddrinfo(x915);
   return Val_unit;
}
value luv_stub_155_luv_get_getnameinfo_trampoline(value x917)
{
   void(* x918)(uv_getnameinfo_t*, int, char*, char*) =
   luv_get_getnameinfo_trampoline();
   return CTYPES_FROM_PTR(x918);
}
value luv_stub_156_luv_getnameinfo(value x923, value x922, value x921,
                                   value x920, value x919)
{
   uv_loop_t* x924 = CTYPES_ADDR_OF_FATPTR(x923);
   uv_getnameinfo_t* x925 = CTYPES_ADDR_OF_FATPTR(x922);
   void(* x926)(uv_getnameinfo_t*, int, char*, char*) =
   CTYPES_ADDR_OF_FATPTR(x921);
   struct sockaddr* x927 = CTYPES_ADDR_OF_FATPTR(x920);
   int x928 = Long_val(x919);
   int x931 = luv_getnameinfo(x924, x925, x926, x927, x928);
   return Val_long(x931);
}
value luv_stub_157_uv_dlopen(value x933, value x932)
{
   char* x934 = CTYPES_PTR_OF_OCAML_STRING(x933);
   uv_lib_t* x935 = CTYPES_ADDR_OF_FATPTR(x932);
   _Bool x936 = uv_dlopen(x934, x935);
   return Val_bool(x936);
}
value luv_stub_158_uv_dlclose(value x937)
{
   uv_lib_t* x938 = CTYPES_ADDR_OF_FATPTR(x937);
   uv_dlclose(x938);
   return Val_unit;
}
value luv_stub_159_uv_dlsym(value x942, value x941, value x940)
{
   uv_lib_t* x943 = CTYPES_ADDR_OF_FATPTR(x942);
   char* x944 = CTYPES_PTR_OF_OCAML_STRING(x941);
   void** x945 = CTYPES_ADDR_OF_FATPTR(x940);
   _Bool x946 = uv_dlsym(x943, x944, x945);
   return Val_bool(x946);
}
value luv_stub_160_luv_dlerror(value x947)
{
   uv_lib_t* x948 = CTYPES_ADDR_OF_FATPTR(x947);
   char* x949 = luv_dlerror(x948);
   return CTYPES_FROM_PTR(x949);
}
value luv_stub_161_uv_get_osfhandle(value x950)
{
   int x951 = Long_val(x950);
   uv_os_fd_t x954 = uv_get_osfhandle(x951);
   return ctypes_copy_bytes(&x954, 4);
}
value luv_stub_162_uv_open_osfhandle(value x955)
{
   void* x956 = CTYPES_ADDR_OF_FATPTR(x955);
   uv_os_fd_t x958 = *(uv_os_fd_t*)x956;
   int x959 = uv_open_osfhandle(x958);
   return Val_long(x959);
}
value luv_stub_163_luv_is_invalid_handle_value(value x960)
{
   void* x961 = CTYPES_ADDR_OF_FATPTR(x960);
   uv_os_fd_t x963 = *(uv_os_fd_t*)x961;
   _Bool x964 = luv_is_invalid_handle_value(x963);
   return Val_bool(x964);
}
value luv_stub_164_luv_is_invalid_socket_value(value x965)
{
   void* x966 = CTYPES_ADDR_OF_FATPTR(x965);
   uv_os_sock_t x968 = *(uv_os_sock_t*)x966;
   _Bool x969 = luv_is_invalid_socket_value(x968);
   return Val_bool(x969);
}
value luv_stub_165_memcpy(value x972, value x971, value x970)
{
   unsigned char* x973 = CTYPES_PTR_OF_OCAML_BYTES(x972);
   char* x974 = CTYPES_ADDR_OF_FATPTR(x971);
   int x975 = Long_val(x970);
   memcpy(x973, x974, x975);
   return Val_unit;
}
value luv_stub_166_memcpy(value x981, value x980, value x979)
{
   char* x982 = CTYPES_ADDR_OF_FATPTR(x981);
   unsigned char* x983 = CTYPES_PTR_OF_OCAML_BYTES(x980);
   int x984 = Long_val(x979);
   memcpy(x982, x983, x984);
   return Val_unit;
}
value luv_stub_167_luv_get_work_trampoline(value x988)
{
   void(* x989)(uv_work_t*) = luv_get_work_trampoline();
   return CTYPES_FROM_PTR(x989);
}
value luv_stub_168_luv_get_after_work_trampoline(value x990)
{
   void(* x991)(uv_work_t*, int) = luv_get_after_work_trampoline();
   return CTYPES_FROM_PTR(x991);
}
value luv_stub_169_luv_get_c_work_trampoline(value x992)
{
   void(* x993)(uv_work_t*) = luv_get_c_work_trampoline();
   return CTYPES_FROM_PTR(x993);
}
value luv_stub_170_luv_get_after_c_work_trampoline(value x994)
{
   void(* x995)(uv_work_t*, int) = luv_get_after_c_work_trampoline();
   return CTYPES_FROM_PTR(x995);
}
value luv_stub_171_luv_add_c_function_and_argument(value x998, value x997,
                                                   value x996)
{
   uv_work_t* x999 = CTYPES_ADDR_OF_FATPTR(x998);
   intnat x1000 = Nativeint_val(x997);
   intnat x1003 = Nativeint_val(x996);
   _Bool x1006 = luv_add_c_function_and_argument(x999, x1000, x1003);
   return Val_bool(x1006);
}
value luv_stub_172_uv_queue_work(value x1010, value x1009, value x1008,
                                 value x1007)
{
   uv_loop_t* x1011 = CTYPES_ADDR_OF_FATPTR(x1010);
   uv_work_t* x1012 = CTYPES_ADDR_OF_FATPTR(x1009);
   void(* x1013)(uv_work_t*) = CTYPES_ADDR_OF_FATPTR(x1008);
   void(* x1014)(uv_work_t*, int) = CTYPES_ADDR_OF_FATPTR(x1007);
   int x1015 = uv_queue_work(x1011, x1012, x1013, x1014);
   return Val_long(x1015);
}
value luv_stub_173_luv_get_thread_trampoline(value x1016)
{
   void(* x1017)(void*) = luv_get_thread_trampoline();
   return CTYPES_FROM_PTR(x1017);
}
value luv_stub_174_uv_thread_create_ex(value x1021, value x1020, value x1019,
                                       value x1018)
{
   uv_thread_t* x1022 = CTYPES_ADDR_OF_FATPTR(x1021);
   uv_thread_options_t* x1023 = CTYPES_ADDR_OF_FATPTR(x1020);
   void(* x1024)(void*) = CTYPES_ADDR_OF_FATPTR(x1019);
   void* x1025 = CTYPES_ADDR_OF_FATPTR(x1018);
   int x1026 = uv_thread_create_ex(x1022, x1023, x1024, x1025);
   return Val_long(x1026);
}
value luv_stub_175_luv_thread_create_c(value x1030, value x1029, value x1028,
                                       value x1027)
{
   uv_thread_t* x1031 = CTYPES_ADDR_OF_FATPTR(x1030);
   uv_thread_options_t* x1032 = CTYPES_ADDR_OF_FATPTR(x1029);
   intnat x1033 = Nativeint_val(x1028);
   intnat x1036 = Nativeint_val(x1027);
   int x1039 = luv_thread_create_c(x1031, x1032, x1033, x1036);
   return Val_long(x1039);
}
value luv_stub_176_uv_thread_self(value x1040)
{
   uv_thread_t x1041 = uv_thread_self();
   return ctypes_copy_bytes(&x1041, 8);
}
value luv_stub_177_uv_thread_equal(value x1043, value x1042)
{
   uv_thread_t* x1044 = CTYPES_ADDR_OF_FATPTR(x1043);
   uv_thread_t* x1045 = CTYPES_ADDR_OF_FATPTR(x1042);
   _Bool x1046 = uv_thread_equal(x1044, x1045);
   return Val_bool(x1046);
}
value luv_stub_178_uv_key_create(value x1047)
{
   uv_key_t* x1048 = CTYPES_ADDR_OF_FATPTR(x1047);
   int x1049 = uv_key_create(x1048);
   return Val_long(x1049);
}
value luv_stub_179_uv_key_delete(value x1050)
{
   uv_key_t* x1051 = CTYPES_ADDR_OF_FATPTR(x1050);
   uv_key_delete(x1051);
   return Val_unit;
}
value luv_stub_180_uv_key_get(value x1053)
{
   uv_key_t* x1054 = CTYPES_ADDR_OF_FATPTR(x1053);
   void* x1055 = uv_key_get(x1054);
   return CTYPES_FROM_PTR(x1055);
}
value luv_stub_181_uv_key_set(value x1057, value x1056)
{
   uv_key_t* x1058 = CTYPES_ADDR_OF_FATPTR(x1057);
   void* x1059 = CTYPES_ADDR_OF_FATPTR(x1056);
   uv_key_set(x1058, x1059);
   return Val_unit;
}
value luv_stub_182_luv_get_once_trampoline(value x1061)
{
   void(* x1062)(void) = luv_get_once_trampoline();
   return CTYPES_FROM_PTR(x1062);
}
value luv_stub_183_luv_once_init(value x1063)
{
   uv_once_t* x1064 = CTYPES_ADDR_OF_FATPTR(x1063);
   int x1065 = luv_once_init(x1064);
   return Val_long(x1065);
}
value luv_stub_184_uv_once(value x1067, value x1066)
{
   uv_once_t* x1068 = CTYPES_ADDR_OF_FATPTR(x1067);
   void(* x1069)(void) = CTYPES_ADDR_OF_FATPTR(x1066);
   uv_once(x1068, x1069);
   return Val_unit;
}
value luv_stub_185_uv_mutex_init(value x1071)
{
   uv_mutex_t* x1072 = CTYPES_ADDR_OF_FATPTR(x1071);
   int x1073 = uv_mutex_init(x1072);
   return Val_long(x1073);
}
value luv_stub_186_uv_mutex_init_recursive(value x1074)
{
   uv_mutex_t* x1075 = CTYPES_ADDR_OF_FATPTR(x1074);
   int x1076 = uv_mutex_init_recursive(x1075);
   return Val_long(x1076);
}
value luv_stub_187_uv_mutex_destroy(value x1077)
{
   uv_mutex_t* x1078 = CTYPES_ADDR_OF_FATPTR(x1077);
   uv_mutex_destroy(x1078);
   return Val_unit;
}
value luv_stub_188_uv_mutex_trylock(value x1080)
{
   uv_mutex_t* x1081 = CTYPES_ADDR_OF_FATPTR(x1080);
   int x1082 = uv_mutex_trylock(x1081);
   return Val_long(x1082);
}
value luv_stub_189_uv_mutex_unlock(value x1083)
{
   uv_mutex_t* x1084 = CTYPES_ADDR_OF_FATPTR(x1083);
   uv_mutex_unlock(x1084);
   return Val_unit;
}
value luv_stub_190_uv_rwlock_init(value x1086)
{
   uv_rwlock_t* x1087 = CTYPES_ADDR_OF_FATPTR(x1086);
   int x1088 = uv_rwlock_init(x1087);
   return Val_long(x1088);
}
value luv_stub_191_uv_rwlock_destroy(value x1089)
{
   uv_rwlock_t* x1090 = CTYPES_ADDR_OF_FATPTR(x1089);
   uv_rwlock_destroy(x1090);
   return Val_unit;
}
value luv_stub_192_uv_rwlock_tryrdlock(value x1092)
{
   uv_rwlock_t* x1093 = CTYPES_ADDR_OF_FATPTR(x1092);
   int x1094 = uv_rwlock_tryrdlock(x1093);
   return Val_long(x1094);
}
value luv_stub_193_uv_rwlock_rdunlock(value x1095)
{
   uv_rwlock_t* x1096 = CTYPES_ADDR_OF_FATPTR(x1095);
   uv_rwlock_rdunlock(x1096);
   return Val_unit;
}
value luv_stub_194_uv_rwlock_trywrlock(value x1098)
{
   uv_rwlock_t* x1099 = CTYPES_ADDR_OF_FATPTR(x1098);
   int x1100 = uv_rwlock_trywrlock(x1099);
   return Val_long(x1100);
}
value luv_stub_195_uv_rwlock_wrunlock(value x1101)
{
   uv_rwlock_t* x1102 = CTYPES_ADDR_OF_FATPTR(x1101);
   uv_rwlock_wrunlock(x1102);
   return Val_unit;
}
value luv_stub_196_uv_sem_init(value x1105, value x1104)
{
   uv_sem_t* x1106 = CTYPES_ADDR_OF_FATPTR(x1105);
   unsigned int x1107 = ctypes_uint_val(x1104);
   int x1110 = uv_sem_init(x1106, x1107);
   return Val_long(x1110);
}
value luv_stub_197_uv_sem_destroy(value x1111)
{
   uv_sem_t* x1112 = CTYPES_ADDR_OF_FATPTR(x1111);
   uv_sem_destroy(x1112);
   return Val_unit;
}
value luv_stub_198_uv_sem_post(value x1114)
{
   uv_sem_t* x1115 = CTYPES_ADDR_OF_FATPTR(x1114);
   uv_sem_post(x1115);
   return Val_unit;
}
value luv_stub_199_uv_sem_trywait(value x1117)
{
   uv_sem_t* x1118 = CTYPES_ADDR_OF_FATPTR(x1117);
   int x1119 = uv_sem_trywait(x1118);
   return Val_long(x1119);
}
value luv_stub_200_uv_cond_init(value x1120)
{
   uv_cond_t* x1121 = CTYPES_ADDR_OF_FATPTR(x1120);
   int x1122 = uv_cond_init(x1121);
   return Val_long(x1122);
}
value luv_stub_201_uv_cond_destroy(value x1123)
{
   uv_cond_t* x1124 = CTYPES_ADDR_OF_FATPTR(x1123);
   uv_cond_destroy(x1124);
   return Val_unit;
}
value luv_stub_202_uv_cond_signal(value x1126)
{
   uv_cond_t* x1127 = CTYPES_ADDR_OF_FATPTR(x1126);
   uv_cond_signal(x1127);
   return Val_unit;
}
value luv_stub_203_uv_cond_broadcast(value x1129)
{
   uv_cond_t* x1130 = CTYPES_ADDR_OF_FATPTR(x1129);
   uv_cond_broadcast(x1130);
   return Val_unit;
}
value luv_stub_204_uv_barrier_init(value x1133, value x1132)
{
   uv_barrier_t* x1134 = CTYPES_ADDR_OF_FATPTR(x1133);
   unsigned int x1135 = ctypes_uint_val(x1132);
   int x1138 = uv_barrier_init(x1134, x1135);
   return Val_long(x1138);
}
value luv_stub_205_uv_barrier_destroy(value x1139)
{
   uv_barrier_t* x1140 = CTYPES_ADDR_OF_FATPTR(x1139);
   uv_barrier_destroy(x1140);
   return Val_unit;
}
value luv_stub_206_uv_ip4_addr(value x1144, value x1143, value x1142)
{
   char* x1145 = CTYPES_PTR_OF_OCAML_STRING(x1144);
   int x1146 = Long_val(x1143);
   struct sockaddr_in* x1149 = CTYPES_ADDR_OF_FATPTR(x1142);
   int x1150 = uv_ip4_addr(x1145, x1146, x1149);
   return Val_long(x1150);
}
value luv_stub_207_uv_ip6_addr(value x1153, value x1152, value x1151)
{
   char* x1154 = CTYPES_PTR_OF_OCAML_STRING(x1153);
   int x1155 = Long_val(x1152);
   struct sockaddr_in6* x1158 = CTYPES_ADDR_OF_FATPTR(x1151);
   int x1159 = uv_ip6_addr(x1154, x1155, x1158);
   return Val_long(x1159);
}
value luv_stub_208_uv_ip4_name(value x1162, value x1161, value x1160)
{
   struct sockaddr_in* x1163 = CTYPES_ADDR_OF_FATPTR(x1162);
   unsigned char* x1164 = CTYPES_PTR_OF_OCAML_BYTES(x1161);
   size_t x1165 = ctypes_size_t_val(x1160);
   int x1168 = uv_ip4_name(x1163, x1164, x1165);
   return Val_long(x1168);
}
value luv_stub_209_uv_ip6_name(value x1171, value x1170, value x1169)
{
   struct sockaddr_in6* x1172 = CTYPES_ADDR_OF_FATPTR(x1171);
   unsigned char* x1173 = CTYPES_PTR_OF_OCAML_BYTES(x1170);
   size_t x1174 = ctypes_size_t_val(x1169);
   int x1177 = uv_ip6_name(x1172, x1173, x1174);
   return Val_long(x1177);
}
value luv_stub_210_memcpy(value x1180, value x1179, value x1178)
{
   struct sockaddr_storage* x1181 = CTYPES_ADDR_OF_FATPTR(x1180);
   struct sockaddr* x1182 = CTYPES_ADDR_OF_FATPTR(x1179);
   int x1183 = Long_val(x1178);
   memcpy(x1181, x1182, x1183);
   return Val_unit;
}
value luv_stub_211_ntohs(value x1187)
{
   unsigned short x1188 = ctypes_ushort_val(x1187);
   unsigned short x1191 = ntohs(x1188);
   return ctypes_copy_ushort(x1191);
}
value luv_stub_212_luv_sa_family_to_int(value x1192)
{
   void* x1193 = CTYPES_ADDR_OF_FATPTR(x1192);
   sa_family_t x1195 = *(sa_family_t*)x1193;
   int x1196 = luv_sa_family_to_int(x1195);
   return Val_long(x1196);
}
value luv_stub_213_uv_resident_set_memory(value x1197)
{
   size_t* x1198 = CTYPES_ADDR_OF_FATPTR(x1197);
   int x1199 = uv_resident_set_memory(x1198);
   return Val_long(x1199);
}
value luv_stub_214_uv_uptime(value x1200)
{
   double* x1201 = CTYPES_ADDR_OF_FATPTR(x1200);
   int x1202 = uv_uptime(x1201);
   return Val_long(x1202);
}
value luv_stub_215_uv_loadavg(value x1203)
{
   double* x1204 = CTYPES_ADDR_OF_FATPTR(x1203);
   uv_loadavg(x1204);
   return Val_unit;
}
value luv_stub_216_uv_get_free_memory(value x1206)
{
   uint64_t x1207 = uv_get_free_memory();
   return integers_copy_uint64(x1207);
}
value luv_stub_217_uv_get_total_memory(value x1208)
{
   uint64_t x1209 = uv_get_total_memory();
   return integers_copy_uint64(x1209);
}
value luv_stub_218_uv_get_constrained_memory(value x1210)
{
   uint64_t x1211 = uv_get_constrained_memory();
   return integers_copy_uint64(x1211);
}
value luv_stub_219_uv_os_getpriority(value x1213, value x1212)
{
   int x1214 = Long_val(x1213);
   int* x1217 = CTYPES_ADDR_OF_FATPTR(x1212);
   int x1218 = uv_os_getpriority(x1214, x1217);
   return Val_long(x1218);
}
value luv_stub_220_uv_os_setpriority(value x1220, value x1219)
{
   int x1221 = Long_val(x1220);
   int x1224 = Long_val(x1219);
   int x1227 = uv_os_setpriority(x1221, x1224);
   return Val_long(x1227);
}
value luv_stub_221_uv_getrusage(value x1228)
{
   uv_rusage_t* x1229 = CTYPES_ADDR_OF_FATPTR(x1228);
   int x1230 = uv_getrusage(x1229);
   return Val_long(x1230);
}
value luv_stub_222_uv_os_getpid(value x1231)
{
   int x1232 = uv_os_getpid();
   return Val_long(x1232);
}
value luv_stub_223_uv_os_getppid(value x1233)
{
   int x1234 = uv_os_getppid();
   return Val_long(x1234);
}
value luv_stub_224_uv_available_parallelism(value x1235)
{
   int x1236 = uv_available_parallelism();
   return Val_long(x1236);
}
value luv_stub_225_uv_cpu_info(value x1238, value x1237)
{
   uv_cpu_info_t** x1239 = CTYPES_ADDR_OF_FATPTR(x1238);
   int* x1240 = CTYPES_ADDR_OF_FATPTR(x1237);
   int x1241 = uv_cpu_info(x1239, x1240);
   return Val_long(x1241);
}
value luv_stub_226_uv_free_cpu_info(value x1243, value x1242)
{
   uv_cpu_info_t* x1244 = CTYPES_ADDR_OF_FATPTR(x1243);
   int x1245 = Long_val(x1242);
   uv_free_cpu_info(x1244, x1245);
   return Val_unit;
}
value luv_stub_227_uv_interface_addresses(value x1250, value x1249)
{
   struct uv_interface_address_s** x1251 = CTYPES_ADDR_OF_FATPTR(x1250);
   int* x1252 = CTYPES_ADDR_OF_FATPTR(x1249);
   int x1253 = uv_interface_addresses(x1251, x1252);
   return Val_long(x1253);
}
value luv_stub_228_uv_free_interface_addresses(value x1255, value x1254)
{
   struct uv_interface_address_s* x1256 = CTYPES_ADDR_OF_FATPTR(x1255);
   int x1257 = Long_val(x1254);
   uv_free_interface_addresses(x1256, x1257);
   return Val_unit;
}
value luv_stub_229_uv_if_indextoname(value x1263, value x1262, value x1261)
{
   unsigned int x1264 = ctypes_uint_val(x1263);
   unsigned char* x1267 = CTYPES_PTR_OF_OCAML_BYTES(x1262);
   size_t* x1268 = CTYPES_ADDR_OF_FATPTR(x1261);
   int x1269 = uv_if_indextoname(x1264, x1267, x1268);
   return Val_long(x1269);
}
value luv_stub_230_uv_if_indextoiid(value x1272, value x1271, value x1270)
{
   unsigned int x1273 = ctypes_uint_val(x1272);
   unsigned char* x1276 = CTYPES_PTR_OF_OCAML_BYTES(x1271);
   size_t* x1277 = CTYPES_ADDR_OF_FATPTR(x1270);
   int x1278 = uv_if_indextoiid(x1273, x1276, x1277);
   return Val_long(x1278);
}
value luv_stub_231_uv_os_gethostname(value x1280, value x1279)
{
   unsigned char* x1281 = CTYPES_PTR_OF_OCAML_BYTES(x1280);
   size_t* x1282 = CTYPES_ADDR_OF_FATPTR(x1279);
   int x1283 = uv_os_gethostname(x1281, x1282);
   return Val_long(x1283);
}
value luv_stub_232_uv_exepath(value x1285, value x1284)
{
   unsigned char* x1286 = CTYPES_PTR_OF_OCAML_BYTES(x1285);
   size_t* x1287 = CTYPES_ADDR_OF_FATPTR(x1284);
   int x1288 = uv_exepath(x1286, x1287);
   return Val_long(x1288);
}
value luv_stub_233_uv_cwd(value x1290, value x1289)
{
   unsigned char* x1291 = CTYPES_PTR_OF_OCAML_BYTES(x1290);
   size_t* x1292 = CTYPES_ADDR_OF_FATPTR(x1289);
   int x1293 = uv_cwd(x1291, x1292);
   return Val_long(x1293);
}
value luv_stub_234_uv_chdir(value x1294)
{
   char* x1295 = CTYPES_PTR_OF_OCAML_STRING(x1294);
   int x1296 = uv_chdir(x1295);
   return Val_long(x1296);
}
value luv_stub_235_uv_os_homedir(value x1298, value x1297)
{
   unsigned char* x1299 = CTYPES_PTR_OF_OCAML_BYTES(x1298);
   size_t* x1300 = CTYPES_ADDR_OF_FATPTR(x1297);
   int x1301 = uv_os_homedir(x1299, x1300);
   return Val_long(x1301);
}
value luv_stub_236_uv_os_tmpdir(value x1303, value x1302)
{
   unsigned char* x1304 = CTYPES_PTR_OF_OCAML_BYTES(x1303);
   size_t* x1305 = CTYPES_ADDR_OF_FATPTR(x1302);
   int x1306 = uv_os_tmpdir(x1304, x1305);
   return Val_long(x1306);
}
value luv_stub_237_uv_os_get_passwd(value x1307)
{
   uv_passwd_t* x1308 = CTYPES_ADDR_OF_FATPTR(x1307);
   int x1309 = uv_os_get_passwd(x1308);
   return Val_long(x1309);
}
value luv_stub_238_uv_os_free_passwd(value x1310)
{
   uv_passwd_t* x1311 = CTYPES_ADDR_OF_FATPTR(x1310);
   uv_os_free_passwd(x1311);
   return Val_unit;
}
value luv_stub_239_uv_os_getenv(value x1315, value x1314, value x1313)
{
   char* x1316 = CTYPES_PTR_OF_OCAML_STRING(x1315);
   unsigned char* x1317 = CTYPES_PTR_OF_OCAML_BYTES(x1314);
   size_t* x1318 = CTYPES_ADDR_OF_FATPTR(x1313);
   int x1319 = uv_os_getenv(x1316, x1317, x1318);
   return Val_long(x1319);
}
value luv_stub_240_uv_os_setenv(value x1321, value x1320)
{
   char* x1322 = CTYPES_PTR_OF_OCAML_STRING(x1321);
   char* x1323 = CTYPES_PTR_OF_OCAML_STRING(x1320);
   int x1324 = uv_os_setenv(x1322, x1323);
   return Val_long(x1324);
}
value luv_stub_241_uv_os_unsetenv(value x1325)
{
   char* x1326 = CTYPES_PTR_OF_OCAML_STRING(x1325);
   int x1327 = uv_os_unsetenv(x1326);
   return Val_long(x1327);
}
value luv_stub_242_uv_os_environ(value x1329, value x1328)
{
   uv_env_item_t** x1330 = CTYPES_ADDR_OF_FATPTR(x1329);
   int* x1331 = CTYPES_ADDR_OF_FATPTR(x1328);
   int x1332 = uv_os_environ(x1330, x1331);
   return Val_long(x1332);
}
value luv_stub_243_uv_os_free_environ(value x1334, value x1333)
{
   uv_env_item_t* x1335 = CTYPES_ADDR_OF_FATPTR(x1334);
   int x1336 = Long_val(x1333);
   uv_os_free_environ(x1335, x1336);
   return Val_unit;
}
value luv_stub_244_luv_os_uname(value x1340)
{
   unsigned char* x1341 = CTYPES_PTR_OF_OCAML_BYTES(x1340);
   int x1342 = luv_os_uname(x1341);
   return Val_long(x1342);
}
value luv_stub_245_uv_gettimeofday(value x1343)
{
   uv_timeval64_t* x1344 = CTYPES_ADDR_OF_FATPTR(x1343);
   int x1345 = uv_gettimeofday(x1344);
   return Val_long(x1345);
}
value luv_stub_246_uv_hrtime(value x1346)
{
   uint64_t x1347 = uv_hrtime();
   return integers_copy_uint64(x1347);
}
value luv_stub_247_luv_get_random_trampoline(value x1348)
{
   void(* x1349)(uv_random_t*, int, void*, size_t) =
   luv_get_random_trampoline();
   return CTYPES_FROM_PTR(x1349);
}
value luv_stub_248_luv_null_random_trampoline(value x1350)
{
   void(* x1351)(uv_random_t*, int, void*, size_t) =
   luv_null_random_trampoline();
   return CTYPES_FROM_PTR(x1351);
}
value luv_stub_249_uv_random(value x1357, value x1356, value x1355,
                             value x1354, value x1353, value x1352)
{
   uv_loop_t* x1358 = CTYPES_ADDR_OF_FATPTR(x1357);
   uv_random_t* x1359 = CTYPES_ADDR_OF_FATPTR(x1356);
   char* x1360 = CTYPES_ADDR_OF_FATPTR(x1355);
   size_t x1361 = ctypes_size_t_val(x1354);
   unsigned int x1364 = ctypes_uint_val(x1353);
   void(* x1367)(uv_random_t*, int, void*, size_t) =
   CTYPES_ADDR_OF_FATPTR(x1352);
   int x1368 = uv_random(x1358, x1359, x1360, x1361, x1364, x1367);
   return Val_long(x1368);
}
value luv_stub_249_uv_random_byte6(value* argv, int argc)
{
   value x1369 = argv[5];
   value x1370 = argv[4];
   value x1371 = argv[3];
   value x1372 = argv[2];
   value x1373 = argv[1];
   value x1374 = argv[0];
   return luv_stub_249_uv_random(x1374, x1373, x1372, x1371, x1370, x1369);
}
value luv_stub_250_uv_metrics_idle_time(value x1375)
{
   uv_loop_t* x1376 = CTYPES_ADDR_OF_FATPTR(x1375);
   uint64_t x1377 = uv_metrics_idle_time(x1376);
   return integers_copy_uint64(x1377);
}
#include "ctypes_cstubs_internals.h"
#include <caml/threads.h>
value luv_stub_blocking_1_uv_run(value x1379, value x1378)
{
   CAMLparam2 (x1379, x1378);;
   uv_loop_t* x1380 = CTYPES_ADDR_OF_FATPTR(x1379);
   uint32_t x1381 = Uint32_val(x1378);
   caml_release_runtime_system();
   _Bool x1384 = uv_run(x1380, x1381);
   caml_acquire_runtime_system();
   value x1385 = Val_bool(x1384);
   CAMLreturnT(value, x1385);
}
value luv_stub_blocking_2_uv_pipe_bind(value x1389, value x1388)
{
   CAMLparam2 (x1389, x1388);;
   uv_pipe_t* x1390 = CTYPES_ADDR_OF_FATPTR(x1389);
   char* x1391 = CTYPES_ADDR_OF_FATPTR(x1388);
   caml_release_runtime_system();
   int x1392 = uv_pipe_bind(x1390, x1391);
   caml_acquire_runtime_system();
   value x1393 = Val_long(x1392);
   CAMLreturnT(value, x1393);
}
value luv_stub_blocking_3_luv_get_fs_trampoline(value x1396)
{
   CAMLparam1 (x1396);;
   caml_release_runtime_system();
   void(* x1397)(uv_fs_t*) = luv_get_fs_trampoline();
   caml_acquire_runtime_system();
   value x1398 = CTYPES_FROM_PTR(x1397);
   CAMLreturnT(value, x1398);
}
value luv_stub_blocking_4_luv_null_fs_callback_pointer(value x1401)
{
   CAMLparam1 (x1401);;
   caml_release_runtime_system();
   void(* x1402)(uv_fs_t*) = luv_null_fs_callback_pointer();
   caml_acquire_runtime_system();
   value x1403 = CTYPES_FROM_PTR(x1402);
   CAMLreturnT(value, x1403);
}
value luv_stub_blocking_5_uv_fs_req_cleanup(value x1406)
{
   CAMLparam1 (x1406);;
   uv_fs_t* x1407 = CTYPES_ADDR_OF_FATPTR(x1406);
   caml_release_runtime_system();
   uv_fs_req_cleanup(x1407);
   caml_acquire_runtime_system();
   value x1409 = Val_unit;
   CAMLreturnT(value, x1409);
}
value luv_stub_blocking_6_uv_fs_close(value x1415, value x1414, value x1413,
                                      value x1412)
{
   CAMLparam4 (x1415, x1414, x1413, x1412);;
   uv_loop_t* x1416 = CTYPES_ADDR_OF_FATPTR(x1415);
   uv_fs_t* x1417 = CTYPES_ADDR_OF_FATPTR(x1414);
   int x1418 = Long_val(x1413);
   void(* x1421)(uv_fs_t*) = CTYPES_ADDR_OF_FATPTR(x1412);
   caml_release_runtime_system();
   int x1422 = uv_fs_close(x1416, x1417, x1418, x1421);
   caml_acquire_runtime_system();
   value x1423 = Val_long(x1422);
   CAMLreturnT(value, x1423);
}
value luv_stub_blocking_7_uv_fs_open(value x1431, value x1430, value x1429,
                                     value x1428, value x1427, value x1426)
{
   CAMLparam5 (x1431, x1430, x1429, x1428, x1427); CAMLxparam1 (x1426);;
   uv_loop_t* x1432 = CTYPES_ADDR_OF_FATPTR(x1431);
   uv_fs_t* x1433 = CTYPES_ADDR_OF_FATPTR(x1430);
   char* x1434 = CTYPES_ADDR_OF_FATPTR(x1429);
   int x1435 = Long_val(x1428);
   int x1438 = Long_val(x1427);
   void(* x1441)(uv_fs_t*) = CTYPES_ADDR_OF_FATPTR(x1426);
   caml_release_runtime_system();
   int x1442 = uv_fs_open(x1432, x1433, x1434, x1435, x1438, x1441);
   caml_acquire_runtime_system();
   value x1443 = Val_long(x1442);
   CAMLreturnT(value, x1443);
}
value luv_stub_blocking_7_uv_fs_open_byte6(value* argv, int argc)
{
   value x1446 = argv[5];
   value x1447 = argv[4];
   value x1448 = argv[3];
   value x1449 = argv[2];
   value x1450 = argv[1];
   value x1451 = argv[0];
   return
     luv_stub_blocking_7_uv_fs_open(x1451, x1450, x1449, x1448, x1447, x1446);
}
value luv_stub_blocking_8_uv_fs_read(value x1458, value x1457, value x1456,
                                     value x1455, value x1454, value x1453,
                                     value x1452)
{
   CAMLparam5 (x1458, x1457, x1456, x1455, x1454);
   CAMLxparam2 (x1453, x1452);;
   uv_loop_t* x1459 = CTYPES_ADDR_OF_FATPTR(x1458);
   uv_fs_t* x1460 = CTYPES_ADDR_OF_FATPTR(x1457);
   int x1461 = Long_val(x1456);
   uv_buf_t* x1464 = CTYPES_ADDR_OF_FATPTR(x1455);
   unsigned int x1465 = ctypes_uint_val(x1454);
   int64_t x1468 = Int64_val(x1453);
   void(* x1471)(uv_fs_t*) = CTYPES_ADDR_OF_FATPTR(x1452);
   caml_release_runtime_system();
   int x1472 = uv_fs_read(x1459, x1460, x1461, x1464, x1465, x1468, x1471);
   caml_acquire_runtime_system();
   value x1473 = Val_long(x1472);
   CAMLreturnT(value, x1473);
}
value luv_stub_blocking_8_uv_fs_read_byte7(value* argv, int argc)
{
   value x1476 = argv[6];
   value x1477 = argv[5];
   value x1478 = argv[4];
   value x1479 = argv[3];
   value x1480 = argv[2];
   value x1481 = argv[1];
   value x1482 = argv[0];
   return
     luv_stub_blocking_8_uv_fs_read(x1482, x1481, x1480, x1479, x1478, 
                                    x1477, x1476);
}
value luv_stub_blocking_9_uv_fs_write(value x1489, value x1488, value x1487,
                                      value x1486, value x1485, value x1484,
                                      value x1483)
{
   CAMLparam5 (x1489, x1488, x1487, x1486, x1485);
   CAMLxparam2 (x1484, x1483);;
   uv_loop_t* x1490 = CTYPES_ADDR_OF_FATPTR(x1489);
   uv_fs_t* x1491 = CTYPES_ADDR_OF_FATPTR(x1488);
   int x1492 = Long_val(x1487);
   uv_buf_t* x1495 = CTYPES_ADDR_OF_FATPTR(x1486);
   unsigned int x1496 = ctypes_uint_val(x1485);
   int64_t x1499 = Int64_val(x1484);
   void(* x1502)(uv_fs_t*) = CTYPES_ADDR_OF_FATPTR(x1483);
   caml_release_runtime_system();
   int x1503 = uv_fs_write(x1490, x1491, x1492, x1495, x1496, x1499, x1502);
   caml_acquire_runtime_system();
   value x1504 = Val_long(x1503);
   CAMLreturnT(value, x1504);
}
value luv_stub_blocking_9_uv_fs_write_byte7(value* argv, int argc)
{
   value x1507 = argv[6];
   value x1508 = argv[5];
   value x1509 = argv[4];
   value x1510 = argv[3];
   value x1511 = argv[2];
   value x1512 = argv[1];
   value x1513 = argv[0];
   return
     luv_stub_blocking_9_uv_fs_write(x1513, x1512, x1511, x1510, x1509,
                                     x1508, x1507);
}
value luv_stub_blocking_10_uv_fs_unlink(value x1517, value x1516,
                                        value x1515, value x1514)
{
   CAMLparam4 (x1517, x1516, x1515, x1514);;
   uv_loop_t* x1518 = CTYPES_ADDR_OF_FATPTR(x1517);
   uv_fs_t* x1519 = CTYPES_ADDR_OF_FATPTR(x1516);
   char* x1520 = CTYPES_ADDR_OF_FATPTR(x1515);
   void(* x1521)(uv_fs_t*) = CTYPES_ADDR_OF_FATPTR(x1514);
   caml_release_runtime_system();
   int x1522 = uv_fs_unlink(x1518, x1519, x1520, x1521);
   caml_acquire_runtime_system();
   value x1523 = Val_long(x1522);
   CAMLreturnT(value, x1523);
}
value luv_stub_blocking_11_uv_fs_mkdir(value x1530, value x1529, value x1528,
                                       value x1527, value x1526)
{
   CAMLparam5 (x1530, x1529, x1528, x1527, x1526); ;
   uv_loop_t* x1531 = CTYPES_ADDR_OF_FATPTR(x1530);
   uv_fs_t* x1532 = CTYPES_ADDR_OF_FATPTR(x1529);
   char* x1533 = CTYPES_ADDR_OF_FATPTR(x1528);
   int x1534 = Long_val(x1527);
   void(* x1537)(uv_fs_t*) = CTYPES_ADDR_OF_FATPTR(x1526);
   caml_release_runtime_system();
   int x1538 = uv_fs_mkdir(x1531, x1532, x1533, x1534, x1537);
   caml_acquire_runtime_system();
   value x1539 = Val_long(x1538);
   CAMLreturnT(value, x1539);
}
value luv_stub_blocking_12_uv_fs_mkdtemp(value x1545, value x1544,
                                         value x1543, value x1542)
{
   CAMLparam4 (x1545, x1544, x1543, x1542);;
   uv_loop_t* x1546 = CTYPES_ADDR_OF_FATPTR(x1545);
   uv_fs_t* x1547 = CTYPES_ADDR_OF_FATPTR(x1544);
   char* x1548 = CTYPES_ADDR_OF_FATPTR(x1543);
   void(* x1549)(uv_fs_t*) = CTYPES_ADDR_OF_FATPTR(x1542);
   caml_release_runtime_system();
   int x1550 = uv_fs_mkdtemp(x1546, x1547, x1548, x1549);
   caml_acquire_runtime_system();
   value x1551 = Val_long(x1550);
   CAMLreturnT(value, x1551);
}
value luv_stub_blocking_13_uv_fs_mkstemp(value x1557, value x1556,
                                         value x1555, value x1554)
{
   CAMLparam4 (x1557, x1556, x1555, x1554);;
   uv_loop_t* x1558 = CTYPES_ADDR_OF_FATPTR(x1557);
   uv_fs_t* x1559 = CTYPES_ADDR_OF_FATPTR(x1556);
   char* x1560 = CTYPES_ADDR_OF_FATPTR(x1555);
   void(* x1561)(uv_fs_t*) = CTYPES_ADDR_OF_FATPTR(x1554);
   caml_release_runtime_system();
   int x1562 = uv_fs_mkstemp(x1558, x1559, x1560, x1561);
   caml_acquire_runtime_system();
   value x1563 = Val_long(x1562);
   CAMLreturnT(value, x1563);
}
value luv_stub_blocking_14_uv_fs_rmdir(value x1569, value x1568, value x1567,
                                       value x1566)
{
   CAMLparam4 (x1569, x1568, x1567, x1566);;
   uv_loop_t* x1570 = CTYPES_ADDR_OF_FATPTR(x1569);
   uv_fs_t* x1571 = CTYPES_ADDR_OF_FATPTR(x1568);
   char* x1572 = CTYPES_ADDR_OF_FATPTR(x1567);
   void(* x1573)(uv_fs_t*) = CTYPES_ADDR_OF_FATPTR(x1566);
   caml_release_runtime_system();
   int x1574 = uv_fs_rmdir(x1570, x1571, x1572, x1573);
   caml_acquire_runtime_system();
   value x1575 = Val_long(x1574);
   CAMLreturnT(value, x1575);
}
value luv_stub_blocking_15_uv_fs_opendir(value x1581, value x1580,
                                         value x1579, value x1578)
{
   CAMLparam4 (x1581, x1580, x1579, x1578);;
   uv_loop_t* x1582 = CTYPES_ADDR_OF_FATPTR(x1581);
   uv_fs_t* x1583 = CTYPES_ADDR_OF_FATPTR(x1580);
   char* x1584 = CTYPES_ADDR_OF_FATPTR(x1579);
   void(* x1585)(uv_fs_t*) = CTYPES_ADDR_OF_FATPTR(x1578);
   caml_release_runtime_system();
   int x1586 = uv_fs_opendir(x1582, x1583, x1584, x1585);
   caml_acquire_runtime_system();
   value x1587 = Val_long(x1586);
   CAMLreturnT(value, x1587);
}
value luv_stub_blocking_16_uv_fs_closedir(value x1593, value x1592,
                                          value x1591, value x1590)
{
   CAMLparam4 (x1593, x1592, x1591, x1590);;
   uv_loop_t* x1594 = CTYPES_ADDR_OF_FATPTR(x1593);
   uv_fs_t* x1595 = CTYPES_ADDR_OF_FATPTR(x1592);
   uv_dir_t* x1596 = CTYPES_ADDR_OF_FATPTR(x1591);
   void(* x1597)(uv_fs_t*) = CTYPES_ADDR_OF_FATPTR(x1590);
   caml_release_runtime_system();
   int x1598 = uv_fs_closedir(x1594, x1595, x1596, x1597);
   caml_acquire_runtime_system();
   value x1599 = Val_long(x1598);
   CAMLreturnT(value, x1599);
}
value luv_stub_blocking_17_uv_fs_readdir(value x1605, value x1604,
                                         value x1603, value x1602)
{
   CAMLparam4 (x1605, x1604, x1603, x1602);;
   uv_loop_t* x1606 = CTYPES_ADDR_OF_FATPTR(x1605);
   uv_fs_t* x1607 = CTYPES_ADDR_OF_FATPTR(x1604);
   uv_dir_t* x1608 = CTYPES_ADDR_OF_FATPTR(x1603);
   void(* x1609)(uv_fs_t*) = CTYPES_ADDR_OF_FATPTR(x1602);
   caml_release_runtime_system();
   int x1610 = uv_fs_readdir(x1606, x1607, x1608, x1609);
   caml_acquire_runtime_system();
   value x1611 = Val_long(x1610);
   CAMLreturnT(value, x1611);
}
value luv_stub_blocking_18_uv_fs_scandir(value x1618, value x1617,
                                         value x1616, value x1615,
                                         value x1614)
{
   CAMLparam5 (x1618, x1617, x1616, x1615, x1614); ;
   uv_loop_t* x1619 = CTYPES_ADDR_OF_FATPTR(x1618);
   uv_fs_t* x1620 = CTYPES_ADDR_OF_FATPTR(x1617);
   char* x1621 = CTYPES_ADDR_OF_FATPTR(x1616);
   int x1622 = Long_val(x1615);
   void(* x1625)(uv_fs_t*) = CTYPES_ADDR_OF_FATPTR(x1614);
   caml_release_runtime_system();
   int x1626 = uv_fs_scandir(x1619, x1620, x1621, x1622, x1625);
   caml_acquire_runtime_system();
   value x1627 = Val_long(x1626);
   CAMLreturnT(value, x1627);
}
value luv_stub_blocking_19_uv_fs_scandir_next(value x1631, value x1630)
{
   CAMLparam2 (x1631, x1630);;
   uv_fs_t* x1632 = CTYPES_ADDR_OF_FATPTR(x1631);
   uv_dirent_t* x1633 = CTYPES_ADDR_OF_FATPTR(x1630);
   caml_release_runtime_system();
   int x1634 = uv_fs_scandir_next(x1632, x1633);
   caml_acquire_runtime_system();
   value x1635 = Val_long(x1634);
   CAMLreturnT(value, x1635);
}
value luv_stub_blocking_20_uv_fs_stat(value x1641, value x1640, value x1639,
                                      value x1638)
{
   CAMLparam4 (x1641, x1640, x1639, x1638);;
   uv_loop_t* x1642 = CTYPES_ADDR_OF_FATPTR(x1641);
   uv_fs_t* x1643 = CTYPES_ADDR_OF_FATPTR(x1640);
   char* x1644 = CTYPES_ADDR_OF_FATPTR(x1639);
   void(* x1645)(uv_fs_t*) = CTYPES_ADDR_OF_FATPTR(x1638);
   caml_release_runtime_system();
   int x1646 = uv_fs_stat(x1642, x1643, x1644, x1645);
   caml_acquire_runtime_system();
   value x1647 = Val_long(x1646);
   CAMLreturnT(value, x1647);
}
value luv_stub_blocking_21_uv_fs_lstat(value x1653, value x1652, value x1651,
                                       value x1650)
{
   CAMLparam4 (x1653, x1652, x1651, x1650);;
   uv_loop_t* x1654 = CTYPES_ADDR_OF_FATPTR(x1653);
   uv_fs_t* x1655 = CTYPES_ADDR_OF_FATPTR(x1652);
   char* x1656 = CTYPES_ADDR_OF_FATPTR(x1651);
   void(* x1657)(uv_fs_t*) = CTYPES_ADDR_OF_FATPTR(x1650);
   caml_release_runtime_system();
   int x1658 = uv_fs_lstat(x1654, x1655, x1656, x1657);
   caml_acquire_runtime_system();
   value x1659 = Val_long(x1658);
   CAMLreturnT(value, x1659);
}
value luv_stub_blocking_22_uv_fs_fstat(value x1665, value x1664, value x1663,
                                       value x1662)
{
   CAMLparam4 (x1665, x1664, x1663, x1662);;
   uv_loop_t* x1666 = CTYPES_ADDR_OF_FATPTR(x1665);
   uv_fs_t* x1667 = CTYPES_ADDR_OF_FATPTR(x1664);
   int x1668 = Long_val(x1663);
   void(* x1671)(uv_fs_t*) = CTYPES_ADDR_OF_FATPTR(x1662);
   caml_release_runtime_system();
   int x1672 = uv_fs_fstat(x1666, x1667, x1668, x1671);
   caml_acquire_runtime_system();
   value x1673 = Val_long(x1672);
   CAMLreturnT(value, x1673);
}
value luv_stub_blocking_23_uv_fs_statfs(value x1679, value x1678,
                                        value x1677, value x1676)
{
   CAMLparam4 (x1679, x1678, x1677, x1676);;
   uv_loop_t* x1680 = CTYPES_ADDR_OF_FATPTR(x1679);
   uv_fs_t* x1681 = CTYPES_ADDR_OF_FATPTR(x1678);
   char* x1682 = CTYPES_ADDR_OF_FATPTR(x1677);
   void(* x1683)(uv_fs_t*) = CTYPES_ADDR_OF_FATPTR(x1676);
   caml_release_runtime_system();
   int x1684 = uv_fs_statfs(x1680, x1681, x1682, x1683);
   caml_acquire_runtime_system();
   value x1685 = Val_long(x1684);
   CAMLreturnT(value, x1685);
}
value luv_stub_blocking_24_uv_fs_rename(value x1692, value x1691,
                                        value x1690, value x1689,
                                        value x1688)
{
   CAMLparam5 (x1692, x1691, x1690, x1689, x1688); ;
   uv_loop_t* x1693 = CTYPES_ADDR_OF_FATPTR(x1692);
   uv_fs_t* x1694 = CTYPES_ADDR_OF_FATPTR(x1691);
   char* x1695 = CTYPES_ADDR_OF_FATPTR(x1690);
   char* x1696 = CTYPES_ADDR_OF_FATPTR(x1689);
   void(* x1697)(uv_fs_t*) = CTYPES_ADDR_OF_FATPTR(x1688);
   caml_release_runtime_system();
   int x1698 = uv_fs_rename(x1693, x1694, x1695, x1696, x1697);
   caml_acquire_runtime_system();
   value x1699 = Val_long(x1698);
   CAMLreturnT(value, x1699);
}
value luv_stub_blocking_25_uv_fs_fsync(value x1705, value x1704, value x1703,
                                       value x1702)
{
   CAMLparam4 (x1705, x1704, x1703, x1702);;
   uv_loop_t* x1706 = CTYPES_ADDR_OF_FATPTR(x1705);
   uv_fs_t* x1707 = CTYPES_ADDR_OF_FATPTR(x1704);
   int x1708 = Long_val(x1703);
   void(* x1711)(uv_fs_t*) = CTYPES_ADDR_OF_FATPTR(x1702);
   caml_release_runtime_system();
   int x1712 = uv_fs_fsync(x1706, x1707, x1708, x1711);
   caml_acquire_runtime_system();
   value x1713 = Val_long(x1712);
   CAMLreturnT(value, x1713);
}
value luv_stub_blocking_26_uv_fs_fdatasync(value x1719, value x1718,
                                           value x1717, value x1716)
{
   CAMLparam4 (x1719, x1718, x1717, x1716);;
   uv_loop_t* x1720 = CTYPES_ADDR_OF_FATPTR(x1719);
   uv_fs_t* x1721 = CTYPES_ADDR_OF_FATPTR(x1718);
   int x1722 = Long_val(x1717);
   void(* x1725)(uv_fs_t*) = CTYPES_ADDR_OF_FATPTR(x1716);
   caml_release_runtime_system();
   int x1726 = uv_fs_fdatasync(x1720, x1721, x1722, x1725);
   caml_acquire_runtime_system();
   value x1727 = Val_long(x1726);
   CAMLreturnT(value, x1727);
}
value luv_stub_blocking_27_uv_fs_ftruncate(value x1734, value x1733,
                                           value x1732, value x1731,
                                           value x1730)
{
   CAMLparam5 (x1734, x1733, x1732, x1731, x1730); ;
   uv_loop_t* x1735 = CTYPES_ADDR_OF_FATPTR(x1734);
   uv_fs_t* x1736 = CTYPES_ADDR_OF_FATPTR(x1733);
   int x1737 = Long_val(x1732);
   int64_t x1740 = Int64_val(x1731);
   void(* x1743)(uv_fs_t*) = CTYPES_ADDR_OF_FATPTR(x1730);
   caml_release_runtime_system();
   int x1744 = uv_fs_ftruncate(x1735, x1736, x1737, x1740, x1743);
   caml_acquire_runtime_system();
   value x1745 = Val_long(x1744);
   CAMLreturnT(value, x1745);
}
value luv_stub_blocking_28_uv_fs_copyfile(value x1753, value x1752,
                                          value x1751, value x1750,
                                          value x1749, value x1748)
{
   CAMLparam5 (x1753, x1752, x1751, x1750, x1749); CAMLxparam1 (x1748);;
   uv_loop_t* x1754 = CTYPES_ADDR_OF_FATPTR(x1753);
   uv_fs_t* x1755 = CTYPES_ADDR_OF_FATPTR(x1752);
   char* x1756 = CTYPES_ADDR_OF_FATPTR(x1751);
   char* x1757 = CTYPES_ADDR_OF_FATPTR(x1750);
   int x1758 = Long_val(x1749);
   void(* x1761)(uv_fs_t*) = CTYPES_ADDR_OF_FATPTR(x1748);
   caml_release_runtime_system();
   int x1762 = uv_fs_copyfile(x1754, x1755, x1756, x1757, x1758, x1761);
   caml_acquire_runtime_system();
   value x1763 = Val_long(x1762);
   CAMLreturnT(value, x1763);
}
value luv_stub_blocking_28_uv_fs_copyfile_byte6(value* argv, int argc)
{
   value x1766 = argv[5];
   value x1767 = argv[4];
   value x1768 = argv[3];
   value x1769 = argv[2];
   value x1770 = argv[1];
   value x1771 = argv[0];
   return
     luv_stub_blocking_28_uv_fs_copyfile(x1771, x1770, x1769, x1768, 
                                         x1767, x1766);
}
value luv_stub_blocking_29_uv_fs_sendfile(value x1778, value x1777,
                                          value x1776, value x1775,
                                          value x1774, value x1773,
                                          value x1772)
{
   CAMLparam5 (x1778, x1777, x1776, x1775, x1774);
   CAMLxparam2 (x1773, x1772);;
   uv_loop_t* x1779 = CTYPES_ADDR_OF_FATPTR(x1778);
   uv_fs_t* x1780 = CTYPES_ADDR_OF_FATPTR(x1777);
   int x1781 = Long_val(x1776);
   int x1784 = Long_val(x1775);
   int64_t x1787 = Int64_val(x1774);
   size_t x1790 = ctypes_size_t_val(x1773);
   void(* x1793)(uv_fs_t*) = CTYPES_ADDR_OF_FATPTR(x1772);
   caml_release_runtime_system();
   int x1794 =
   uv_fs_sendfile(x1779, x1780, x1781, x1784, x1787, x1790, x1793);
   caml_acquire_runtime_system();
   value x1795 = Val_long(x1794);
   CAMLreturnT(value, x1795);
}
value luv_stub_blocking_29_uv_fs_sendfile_byte7(value* argv, int argc)
{
   value x1798 = argv[6];
   value x1799 = argv[5];
   value x1800 = argv[4];
   value x1801 = argv[3];
   value x1802 = argv[2];
   value x1803 = argv[1];
   value x1804 = argv[0];
   return
     luv_stub_blocking_29_uv_fs_sendfile(x1804, x1803, x1802, x1801, 
                                         x1800, x1799, x1798);
}
value luv_stub_blocking_30_uv_fs_access(value x1809, value x1808,
                                        value x1807, value x1806,
                                        value x1805)
{
   CAMLparam5 (x1809, x1808, x1807, x1806, x1805); ;
   uv_loop_t* x1810 = CTYPES_ADDR_OF_FATPTR(x1809);
   uv_fs_t* x1811 = CTYPES_ADDR_OF_FATPTR(x1808);
   char* x1812 = CTYPES_ADDR_OF_FATPTR(x1807);
   int x1813 = Long_val(x1806);
   void(* x1816)(uv_fs_t*) = CTYPES_ADDR_OF_FATPTR(x1805);
   caml_release_runtime_system();
   int x1817 = uv_fs_access(x1810, x1811, x1812, x1813, x1816);
   caml_acquire_runtime_system();
   value x1818 = Val_long(x1817);
   CAMLreturnT(value, x1818);
}
value luv_stub_blocking_31_uv_fs_chmod(value x1825, value x1824, value x1823,
                                       value x1822, value x1821)
{
   CAMLparam5 (x1825, x1824, x1823, x1822, x1821); ;
   uv_loop_t* x1826 = CTYPES_ADDR_OF_FATPTR(x1825);
   uv_fs_t* x1827 = CTYPES_ADDR_OF_FATPTR(x1824);
   char* x1828 = CTYPES_ADDR_OF_FATPTR(x1823);
   int x1829 = Long_val(x1822);
   void(* x1832)(uv_fs_t*) = CTYPES_ADDR_OF_FATPTR(x1821);
   caml_release_runtime_system();
   int x1833 = uv_fs_chmod(x1826, x1827, x1828, x1829, x1832);
   caml_acquire_runtime_system();
   value x1834 = Val_long(x1833);
   CAMLreturnT(value, x1834);
}
value luv_stub_blocking_32_uv_fs_fchmod(value x1841, value x1840,
                                        value x1839, value x1838,
                                        value x1837)
{
   CAMLparam5 (x1841, x1840, x1839, x1838, x1837); ;
   uv_loop_t* x1842 = CTYPES_ADDR_OF_FATPTR(x1841);
   uv_fs_t* x1843 = CTYPES_ADDR_OF_FATPTR(x1840);
   int x1844 = Long_val(x1839);
   int x1847 = Long_val(x1838);
   void(* x1850)(uv_fs_t*) = CTYPES_ADDR_OF_FATPTR(x1837);
   caml_release_runtime_system();
   int x1851 = uv_fs_fchmod(x1842, x1843, x1844, x1847, x1850);
   caml_acquire_runtime_system();
   value x1852 = Val_long(x1851);
   CAMLreturnT(value, x1852);
}
value luv_stub_blocking_33_uv_fs_utime(value x1860, value x1859, value x1858,
                                       value x1857, value x1856, value x1855)
{
   CAMLparam5 (x1860, x1859, x1858, x1857, x1856); CAMLxparam1 (x1855);;
   uv_loop_t* x1861 = CTYPES_ADDR_OF_FATPTR(x1860);
   uv_fs_t* x1862 = CTYPES_ADDR_OF_FATPTR(x1859);
   char* x1863 = CTYPES_ADDR_OF_FATPTR(x1858);
   double x1864 = Double_val(x1857);
   double x1867 = Double_val(x1856);
   void(* x1870)(uv_fs_t*) = CTYPES_ADDR_OF_FATPTR(x1855);
   caml_release_runtime_system();
   int x1871 =
   uv_fs_utime(x1861, x1862, x1863, (float)x1864, (float)x1867, x1870);
   caml_acquire_runtime_system();
   value x1872 = Val_long(x1871);
   CAMLreturnT(value, x1872);
}
value luv_stub_blocking_33_uv_fs_utime_byte6(value* argv, int argc)
{
   value x1875 = argv[5];
   value x1876 = argv[4];
   value x1877 = argv[3];
   value x1878 = argv[2];
   value x1879 = argv[1];
   value x1880 = argv[0];
   return
     luv_stub_blocking_33_uv_fs_utime(x1880, x1879, x1878, x1877, x1876,
                                      x1875);
}
value luv_stub_blocking_34_uv_fs_futime(value x1886, value x1885,
                                        value x1884, value x1883,
                                        value x1882, value x1881)
{
   CAMLparam5 (x1886, x1885, x1884, x1883, x1882); CAMLxparam1 (x1881);;
   uv_loop_t* x1887 = CTYPES_ADDR_OF_FATPTR(x1886);
   uv_fs_t* x1888 = CTYPES_ADDR_OF_FATPTR(x1885);
   int x1889 = Long_val(x1884);
   double x1892 = Double_val(x1883);
   double x1895 = Double_val(x1882);
   void(* x1898)(uv_fs_t*) = CTYPES_ADDR_OF_FATPTR(x1881);
   caml_release_runtime_system();
   int x1899 =
   uv_fs_futime(x1887, x1888, x1889, (float)x1892, (float)x1895, x1898);
   caml_acquire_runtime_system();
   value x1900 = Val_long(x1899);
   CAMLreturnT(value, x1900);
}
value luv_stub_blocking_34_uv_fs_futime_byte6(value* argv, int argc)
{
   value x1903 = argv[5];
   value x1904 = argv[4];
   value x1905 = argv[3];
   value x1906 = argv[2];
   value x1907 = argv[1];
   value x1908 = argv[0];
   return
     luv_stub_blocking_34_uv_fs_futime(x1908, x1907, x1906, x1905, x1904,
                                       x1903);
}
value luv_stub_blocking_35_uv_fs_lutime(value x1914, value x1913,
                                        value x1912, value x1911,
                                        value x1910, value x1909)
{
   CAMLparam5 (x1914, x1913, x1912, x1911, x1910); CAMLxparam1 (x1909);;
   uv_loop_t* x1915 = CTYPES_ADDR_OF_FATPTR(x1914);
   uv_fs_t* x1916 = CTYPES_ADDR_OF_FATPTR(x1913);
   char* x1917 = CTYPES_ADDR_OF_FATPTR(x1912);
   double x1918 = Double_val(x1911);
   double x1921 = Double_val(x1910);
   void(* x1924)(uv_fs_t*) = CTYPES_ADDR_OF_FATPTR(x1909);
   caml_release_runtime_system();
   int x1925 =
   uv_fs_lutime(x1915, x1916, x1917, (float)x1918, (float)x1921, x1924);
   caml_acquire_runtime_system();
   value x1926 = Val_long(x1925);
   CAMLreturnT(value, x1926);
}
value luv_stub_blocking_35_uv_fs_lutime_byte6(value* argv, int argc)
{
   value x1929 = argv[5];
   value x1930 = argv[4];
   value x1931 = argv[3];
   value x1932 = argv[2];
   value x1933 = argv[1];
   value x1934 = argv[0];
   return
     luv_stub_blocking_35_uv_fs_lutime(x1934, x1933, x1932, x1931, x1930,
                                       x1929);
}
value luv_stub_blocking_36_uv_fs_link(value x1939, value x1938, value x1937,
                                      value x1936, value x1935)
{
   CAMLparam5 (x1939, x1938, x1937, x1936, x1935); ;
   uv_loop_t* x1940 = CTYPES_ADDR_OF_FATPTR(x1939);
   uv_fs_t* x1941 = CTYPES_ADDR_OF_FATPTR(x1938);
   char* x1942 = CTYPES_ADDR_OF_FATPTR(x1937);
   char* x1943 = CTYPES_ADDR_OF_FATPTR(x1936);
   void(* x1944)(uv_fs_t*) = CTYPES_ADDR_OF_FATPTR(x1935);
   caml_release_runtime_system();
   int x1945 = uv_fs_link(x1940, x1941, x1942, x1943, x1944);
   caml_acquire_runtime_system();
   value x1946 = Val_long(x1945);
   CAMLreturnT(value, x1946);
}
value luv_stub_blocking_37_uv_fs_symlink(value x1954, value x1953,
                                         value x1952, value x1951,
                                         value x1950, value x1949)
{
   CAMLparam5 (x1954, x1953, x1952, x1951, x1950); CAMLxparam1 (x1949);;
   uv_loop_t* x1955 = CTYPES_ADDR_OF_FATPTR(x1954);
   uv_fs_t* x1956 = CTYPES_ADDR_OF_FATPTR(x1953);
   char* x1957 = CTYPES_ADDR_OF_FATPTR(x1952);
   char* x1958 = CTYPES_ADDR_OF_FATPTR(x1951);
   int x1959 = Long_val(x1950);
   void(* x1962)(uv_fs_t*) = CTYPES_ADDR_OF_FATPTR(x1949);
   caml_release_runtime_system();
   int x1963 = uv_fs_symlink(x1955, x1956, x1957, x1958, x1959, x1962);
   caml_acquire_runtime_system();
   value x1964 = Val_long(x1963);
   CAMLreturnT(value, x1964);
}
value luv_stub_blocking_37_uv_fs_symlink_byte6(value* argv, int argc)
{
   value x1967 = argv[5];
   value x1968 = argv[4];
   value x1969 = argv[3];
   value x1970 = argv[2];
   value x1971 = argv[1];
   value x1972 = argv[0];
   return
     luv_stub_blocking_37_uv_fs_symlink(x1972, x1971, x1970, x1969, x1968,
                                        x1967);
}
value luv_stub_blocking_38_uv_fs_readlink(value x1976, value x1975,
                                          value x1974, value x1973)
{
   CAMLparam4 (x1976, x1975, x1974, x1973);;
   uv_loop_t* x1977 = CTYPES_ADDR_OF_FATPTR(x1976);
   uv_fs_t* x1978 = CTYPES_ADDR_OF_FATPTR(x1975);
   char* x1979 = CTYPES_ADDR_OF_FATPTR(x1974);
   void(* x1980)(uv_fs_t*) = CTYPES_ADDR_OF_FATPTR(x1973);
   caml_release_runtime_system();
   int x1981 = uv_fs_readlink(x1977, x1978, x1979, x1980);
   caml_acquire_runtime_system();
   value x1982 = Val_long(x1981);
   CAMLreturnT(value, x1982);
}
value luv_stub_blocking_39_uv_fs_realpath(value x1988, value x1987,
                                          value x1986, value x1985)
{
   CAMLparam4 (x1988, x1987, x1986, x1985);;
   uv_loop_t* x1989 = CTYPES_ADDR_OF_FATPTR(x1988);
   uv_fs_t* x1990 = CTYPES_ADDR_OF_FATPTR(x1987);
   char* x1991 = CTYPES_ADDR_OF_FATPTR(x1986);
   void(* x1992)(uv_fs_t*) = CTYPES_ADDR_OF_FATPTR(x1985);
   caml_release_runtime_system();
   int x1993 = uv_fs_realpath(x1989, x1990, x1991, x1992);
   caml_acquire_runtime_system();
   value x1994 = Val_long(x1993);
   CAMLreturnT(value, x1994);
}
value luv_stub_blocking_40_uv_fs_chown(value x2002, value x2001, value x2000,
                                       value x1999, value x1998, value x1997)
{
   CAMLparam5 (x2002, x2001, x2000, x1999, x1998); CAMLxparam1 (x1997);;
   uv_loop_t* x2003 = CTYPES_ADDR_OF_FATPTR(x2002);
   uv_fs_t* x2004 = CTYPES_ADDR_OF_FATPTR(x2001);
   char* x2005 = CTYPES_ADDR_OF_FATPTR(x2000);
   int x2006 = Long_val(x1999);
   int x2009 = Long_val(x1998);
   void(* x2012)(uv_fs_t*) = CTYPES_ADDR_OF_FATPTR(x1997);
   caml_release_runtime_system();
   int x2013 = uv_fs_chown(x2003, x2004, x2005, x2006, x2009, x2012);
   caml_acquire_runtime_system();
   value x2014 = Val_long(x2013);
   CAMLreturnT(value, x2014);
}
value luv_stub_blocking_40_uv_fs_chown_byte6(value* argv, int argc)
{
   value x2017 = argv[5];
   value x2018 = argv[4];
   value x2019 = argv[3];
   value x2020 = argv[2];
   value x2021 = argv[1];
   value x2022 = argv[0];
   return
     luv_stub_blocking_40_uv_fs_chown(x2022, x2021, x2020, x2019, x2018,
                                      x2017);
}
value luv_stub_blocking_41_uv_fs_fchown(value x2028, value x2027,
                                        value x2026, value x2025,
                                        value x2024, value x2023)
{
   CAMLparam5 (x2028, x2027, x2026, x2025, x2024); CAMLxparam1 (x2023);;
   uv_loop_t* x2029 = CTYPES_ADDR_OF_FATPTR(x2028);
   uv_fs_t* x2030 = CTYPES_ADDR_OF_FATPTR(x2027);
   int x2031 = Long_val(x2026);
   int x2034 = Long_val(x2025);
   int x2037 = Long_val(x2024);
   void(* x2040)(uv_fs_t*) = CTYPES_ADDR_OF_FATPTR(x2023);
   caml_release_runtime_system();
   int x2041 = uv_fs_fchown(x2029, x2030, x2031, x2034, x2037, x2040);
   caml_acquire_runtime_system();
   value x2042 = Val_long(x2041);
   CAMLreturnT(value, x2042);
}
value luv_stub_blocking_41_uv_fs_fchown_byte6(value* argv, int argc)
{
   value x2045 = argv[5];
   value x2046 = argv[4];
   value x2047 = argv[3];
   value x2048 = argv[2];
   value x2049 = argv[1];
   value x2050 = argv[0];
   return
     luv_stub_blocking_41_uv_fs_fchown(x2050, x2049, x2048, x2047, x2046,
                                       x2045);
}
value luv_stub_blocking_42_uv_fs_lchown(value x2056, value x2055,
                                        value x2054, value x2053,
                                        value x2052, value x2051)
{
   CAMLparam5 (x2056, x2055, x2054, x2053, x2052); CAMLxparam1 (x2051);;
   uv_loop_t* x2057 = CTYPES_ADDR_OF_FATPTR(x2056);
   uv_fs_t* x2058 = CTYPES_ADDR_OF_FATPTR(x2055);
   char* x2059 = CTYPES_ADDR_OF_FATPTR(x2054);
   int x2060 = Long_val(x2053);
   int x2063 = Long_val(x2052);
   void(* x2066)(uv_fs_t*) = CTYPES_ADDR_OF_FATPTR(x2051);
   caml_release_runtime_system();
   int x2067 = uv_fs_lchown(x2057, x2058, x2059, x2060, x2063, x2066);
   caml_acquire_runtime_system();
   value x2068 = Val_long(x2067);
   CAMLreturnT(value, x2068);
}
value luv_stub_blocking_42_uv_fs_lchown_byte6(value* argv, int argc)
{
   value x2071 = argv[5];
   value x2072 = argv[4];
   value x2073 = argv[3];
   value x2074 = argv[2];
   value x2075 = argv[1];
   value x2076 = argv[0];
   return
     luv_stub_blocking_42_uv_fs_lchown(x2076, x2075, x2074, x2073, x2072,
                                       x2071);
}
value luv_stub_blocking_43_uv_fs_get_result(value x2077)
{
   CAMLparam1 (x2077);;
   uv_fs_t* x2078 = CTYPES_ADDR_OF_FATPTR(x2077);
   caml_release_runtime_system();
   ssize_t x2079 = uv_fs_get_result(x2078);
   caml_acquire_runtime_system();
   value x2080 = caml_copy_int64(x2079);
   CAMLreturnT(value, x2080);
}
value luv_stub_blocking_44_uv_fs_get_ptr(value x2083)
{
   CAMLparam1 (x2083);;
   uv_fs_t* x2084 = CTYPES_ADDR_OF_FATPTR(x2083);
   caml_release_runtime_system();
   void* x2085 = uv_fs_get_ptr(x2084);
   caml_acquire_runtime_system();
   value x2086 = CTYPES_FROM_PTR(x2085);
   CAMLreturnT(value, x2086);
}
value luv_stub_blocking_45_uv_fs_get_ptr(value x2089)
{
   CAMLparam1 (x2089);;
   uv_fs_t* x2090 = CTYPES_ADDR_OF_FATPTR(x2089);
   caml_release_runtime_system();
   char* x2091 = uv_fs_get_ptr(x2090);
   caml_acquire_runtime_system();
   value x2092 = CTYPES_FROM_PTR(x2091);
   CAMLreturnT(value, x2092);
}
value luv_stub_blocking_46_luv_fs_get_path(value x2095)
{
   CAMLparam1 (x2095);;
   uv_fs_t* x2096 = CTYPES_ADDR_OF_FATPTR(x2095);
   caml_release_runtime_system();
   char* x2097 = luv_fs_get_path(x2096);
   caml_acquire_runtime_system();
   value x2098 = CTYPES_FROM_PTR(x2097);
   CAMLreturnT(value, x2098);
}
value luv_stub_blocking_47_uv_fs_get_statbuf(value x2101)
{
   CAMLparam1 (x2101);;
   uv_fs_t* x2102 = CTYPES_ADDR_OF_FATPTR(x2101);
   caml_release_runtime_system();
   uv_stat_t* x2103 = uv_fs_get_statbuf(x2102);
   caml_acquire_runtime_system();
   value x2104 = CTYPES_FROM_PTR(x2103);
   CAMLreturnT(value, x2104);
}
value luv_stub_blocking_48_uv_thread_join(value x2107)
{
   CAMLparam1 (x2107);;
   uv_thread_t* x2108 = CTYPES_ADDR_OF_FATPTR(x2107);
   caml_release_runtime_system();
   int x2109 = uv_thread_join(x2108);
   caml_acquire_runtime_system();
   value x2110 = Val_long(x2109);
   CAMLreturnT(value, x2110);
}
value luv_stub_blocking_49_uv_mutex_lock(value x2113)
{
   CAMLparam1 (x2113);;
   uv_mutex_t* x2114 = CTYPES_ADDR_OF_FATPTR(x2113);
   caml_release_runtime_system();
   uv_mutex_lock(x2114);
   caml_acquire_runtime_system();
   value x2116 = Val_unit;
   CAMLreturnT(value, x2116);
}
value luv_stub_blocking_50_uv_rwlock_rdlock(value x2119)
{
   CAMLparam1 (x2119);;
   uv_rwlock_t* x2120 = CTYPES_ADDR_OF_FATPTR(x2119);
   caml_release_runtime_system();
   uv_rwlock_rdlock(x2120);
   caml_acquire_runtime_system();
   value x2122 = Val_unit;
   CAMLreturnT(value, x2122);
}
value luv_stub_blocking_51_uv_rwlock_wrlock(value x2125)
{
   CAMLparam1 (x2125);;
   uv_rwlock_t* x2126 = CTYPES_ADDR_OF_FATPTR(x2125);
   caml_release_runtime_system();
   uv_rwlock_wrlock(x2126);
   caml_acquire_runtime_system();
   value x2128 = Val_unit;
   CAMLreturnT(value, x2128);
}
value luv_stub_blocking_52_uv_sem_wait(value x2131)
{
   CAMLparam1 (x2131);;
   uv_sem_t* x2132 = CTYPES_ADDR_OF_FATPTR(x2131);
   caml_release_runtime_system();
   uv_sem_wait(x2132);
   caml_acquire_runtime_system();
   value x2134 = Val_unit;
   CAMLreturnT(value, x2134);
}
value luv_stub_blocking_53_uv_cond_wait(value x2138, value x2137)
{
   CAMLparam2 (x2138, x2137);;
   uv_cond_t* x2139 = CTYPES_ADDR_OF_FATPTR(x2138);
   uv_mutex_t* x2140 = CTYPES_ADDR_OF_FATPTR(x2137);
   caml_release_runtime_system();
   uv_cond_wait(x2139, x2140);
   caml_acquire_runtime_system();
   value x2142 = Val_unit;
   CAMLreturnT(value, x2142);
}
value luv_stub_blocking_54_uv_cond_timedwait(value x2147, value x2146,
                                             value x2145)
{
   CAMLparam3 (x2147, x2146, x2145);;
   uv_cond_t* x2148 = CTYPES_ADDR_OF_FATPTR(x2147);
   uv_mutex_t* x2149 = CTYPES_ADDR_OF_FATPTR(x2146);
   uint64_t x2150 = Uint64_val(x2145);
   caml_release_runtime_system();
   int x2153 = uv_cond_timedwait(x2148, x2149, x2150);
   caml_acquire_runtime_system();
   value x2154 = Val_long(x2153);
   CAMLreturnT(value, x2154);
}
value luv_stub_blocking_55_uv_barrier_wait(value x2157)
{
   CAMLparam1 (x2157);;
   uv_barrier_t* x2158 = CTYPES_ADDR_OF_FATPTR(x2157);
   caml_release_runtime_system();
   _Bool x2159 = uv_barrier_wait(x2158);
   caml_acquire_runtime_system();
   value x2160 = Val_bool(x2159);
   CAMLreturnT(value, x2160);
}
value luv_stub_blocking_56_uv_sleep(value x2163)
{
   CAMLparam1 (x2163);;
   int x2164 = Long_val(x2163);
   caml_release_runtime_system();
   uv_sleep(x2164);
   caml_acquire_runtime_system();
   value x2168 = Val_unit;
   CAMLreturnT(value, x2168);
}
value luv_stub_blocking_57_uv_random(value x2176, value x2175, value x2174,
                                     value x2173, value x2172, value x2171)
{
   CAMLparam5 (x2176, x2175, x2174, x2173, x2172); CAMLxparam1 (x2171);;
   uv_loop_t* x2177 = CTYPES_ADDR_OF_FATPTR(x2176);
   uv_random_t* x2178 = CTYPES_ADDR_OF_FATPTR(x2175);
   char* x2179 = CTYPES_ADDR_OF_FATPTR(x2174);
   size_t x2180 = ctypes_size_t_val(x2173);
   unsigned int x2183 = ctypes_uint_val(x2172);
   void(* x2186)(uv_random_t*, int, void*, size_t) =
   CTYPES_ADDR_OF_FATPTR(x2171);
   caml_release_runtime_system();
   int x2187 = uv_random(x2177, x2178, x2179, x2180, x2183, x2186);
   caml_acquire_runtime_system();
   value x2188 = Val_long(x2187);
   CAMLreturnT(value, x2188);
}
value luv_stub_blocking_57_uv_random_byte6(value* argv, int argc)
{
   value x2191 = argv[5];
   value x2192 = argv[4];
   value x2193 = argv[3];
   value x2194 = argv[2];
   value x2195 = argv[1];
   value x2196 = argv[0];
   return
     luv_stub_blocking_57_uv_random(x2196, x2195, x2194, x2193, x2192, x2191);
}
